(******************************************************************************)
(*                                                                            *)
(*   Komponenten                                                              *)
(*   TSerial, TSerPort, TSerSel, TSerStdDlg, TSerExtDlg, TCOMComboBox         *)
(*                                                                            *)
(*   Komponenten zur Datenbertragung ber die serielle Schnittstelle,        *)
(*   serielle Schnittstelle als I/O-Port,                                     *)
(*   Dialog und ComboBox zur Auswahl einer Schnittstelle,                     *)
(*   Dialoge zur Einstellung von Schnittstellenparametern                     *)
(*                                                                            *)
(*   (c) 1998-2001  Rainer Reusch und Toolbox                                 *)
(*   (c) 1998-2001  Rainer Reusch und Computer & Literatur Verlag             *)
(*                                                                            *)
(*   Borland Delphi 2.0, 3.0, 4.03, 5.0                                       *)
(*   Borland C++ Builder 1.0, 3.0, 4.0, 5.0                                   *)
(*                                                                            *)
(****V3.5***********************************************************Build 1****)

{
RECHTLICHES:
DIE KOMPONENTENSAMMLUNG "SERIAL" IST  URHEBERRECHTLICH  GESCHTZT.  SIE DARF VON
LESERN DER ZEITSCHRIFT TOOLBOX UND LESERN DES  COMPUTER&LITERATUR-VERLAGES  OHNE
ENTRICHTUNG EINER LIZENZGEBHR BENUTZT WERDEN. DAS  GILT  FR  DIE  PRIVATE  UND
GEWERBLICHE  NUTZUNG.  DIE  WEITERGABE  ODER  DER  VERKAUF  DES  QUELLKODES  IST
VERBOTEN!
DIE PUBLIKATION DER QUELLTEXTE ERFOLGT "AS IS". FR DIE EINHALTUNG ZUGESICHERTER
EIGENSCHAFTEN ODER FR SCHDEN, DIE DURCH DEN  EINSATZ  DER  KOMPONENTENSAMMLUNG
ENTSTANDEN SEIN KNNTEN, BERNEHMEN WEDER  DER  TOOLBOX-VERLAG,  DER  C&L-VERLAG
NOCH DER AUTOR JEGLICHE HAFTUNG. SIE NUTZEN DIE KOMPONENTENSAMMLUNG  AUF  EIGENE
GEFAHR!

nderungen gegenber V1.0:
- Untersttzung aller vom Standarddialog angebotenen Baudraten
- Einstellungsdialog mit erweiterten Mglichkeiten
- ComboBox zur Schnittstellenauswahl

nderungen gegenber V2.0:
- Neue Komponente TSerPort (serielle Schnittstelle als I/O-Port)
- Korrigierte Behandlung vorhandener Schnittstellen
- Korrekturen fr Delphi 2.0

nderungen gegenber V3.02:
- Die Empfangs- und Senderoutinen von TSerial wurden dahingehend
  erweitert, da nun auch unter Windows NT die Anzahl der bertragenen
  Datenbytes als Funktionsergebnis zurck geliefert wird.
- Die Deklaration der Methode TSerial.ReceiveData wurde gendert.

nderungen gegenber V3.1:
- Neue Eigenschaften RTSActive und DTRActive in der Komponente TSerial.
- Untersttzung der Baudraten 50 und 150 Baud in TSerial.
- Mglichkeit zur Festlegung eines Timeout beim Senden und Empfangen (TSerial).
- Thread-Synchronisierung zur Verhinderung eines Stack-Overflow (lt. Leserangabe).

nderungen gegenber V3.2x:
- Delphi 4, 5 und weitere Versionen als Standard. Sonderbehandlung nun fr
  ltere Delphi-Versionen.
- Nun auch fr Borland C++Builder 4 geeignet.
- TSerial: Thread-Synchronisierung nun ber Eigenschaft whlbar (kein Stack-
  Overflow bei sehr langen bertragungen oder bessere Performance).
- TSerial: Neue Eigenschaft EnableEvents. Damit lt sich (vorbergehend)
  global die Ereignisbehandlung deaktivieren.
- TSerial: Der auf Schnittstellenereignisse wartende Thread wird nur noch
  gestartet, wenn mindestens eine Behandlungsroutine zugeordnet ist (keine
  unntige Prozessorauslastung mehr, wenn keine Ereignisbehandlung fest-
  gelegt ist).
- TSerial: Die bertragungsmethoden wurden als Prozeduralvariablen ausgefhrt.
  Abhngig von der Plattform (95/98 oder NT) werden entsprechende Routinen
  zugeordnet. Bessere Performance.
- TSerExtDlg: Ungereimtheiten bei der Auswahl der Baudrate wurden behoben.

nderungen gegenber V3.31
- In den Komponenten TSerSel, TSerExtDlg und TCOMComboBox wird das Fehlen von
  Schnittstellen nun korrekt behandelt.

nderungen gegenber V3.32
- Im Formular TFormCOMSetup (Komponente TSerExtDlg) wurden die Komponenten
  TSpinButton durch TUpDown ersetzt. Damit ist die Komponentensammlung auch fr
  alle Versionen des C++Builder geeignet.
- Formal nun eine Untersttzung bis COM99.
- TSerial: Neue Methoden SetConfig, GetConfig, ConfigToStr, StrToConfig zum
  Speichern und Wiederherstellen von Schnittstellen-Einstellungen.

nderungen gegenber V3.4
- Beseitigung eines Fehlers in TSerPort: Die Eigenschaft Active wird nun auch
  beim Aufruf von OpenComm gesetzt. Damit ist das Schlieen mglich.

nderungen gegenber V3.41
- TSerial: Neue Funktion Purge zum Anhalten der bertragung und Lschen der
  Puffer.
- Variablen und Methoden im Private-Teil von TCustomSerial wurden in den
  Protected-Teil verschoben. Notwendig fr einwandfreie Funktion unter dem
  C++Builder.
- TSerial: nderung in RText_95 und RText_NT. ReadFile wird nur noch aufgerufen,
  wenn sich tatschlich Zeichen im Empfangspuffer befinden. Manahme verhindert
  eine Exception bei leerem Empfangspuffer und dem Versuch, Zeichen ein zu lesen.
- Die neuen Funktionen LastCOM und COMAvailable.

Hinweise:
---------
Die im Implementation-Teil aufgefhrte Konstante MaxPort ist auf den Wert 3
gesetzt. Das heit, es wird bis COM4 geprft, welche Schnittstellen vorhanden
sind. Sollen mehr Schnittstellen geprft werden, ist der Wert der Konstanten
entsprechend zu erhhen. Beachten Sie jedoch, da sich damit die erforderliche
Zeit zur Initialisierung verlngert.
Die vorliegende Version kann hchstens bis COM99 verwendet werden!
Schnittstellennummern grer 99 werden nicht korrekt verarbeitet!

Bekanntes Problem in der Komponente TSerExtDlg:
Bei der Anzeige des Konfigurationsdialoges werden unter gewissen Umstnden
die Einstellungen der Handshakes nicht korrekt angezeigt.

Um die Unit zu compilieren, mssen die Formulardateien FORMSSEL.DFM und
DLGCOM.DFM vorhanden sein.
}

{$IFDEF VER90}  {$DEFINE OLDDELPHI} {$ENDIF}  { Delphi 2 }
{$IFDEF VER100} {$DEFINE OLDDELPHI} {$ENDIF}  { Delphi 3 }
{$IFDEF VER93} {$DEFINE OLDDELPHI} {$ENDIF}   { C++Builder 1 }
{$IFDEF VER110} {$DEFINE OLDDELPHI} {$ENDIF}  { C++Builder 3 }

unit Serial;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  // bertragungsparameter
  TBaudrate   = (br_000050,br_000110,br_000150,br_000300,br_000600,br_001200,
                 br_002400,br_004800,br_009600,br_014400,br_019200,br_038400,
                 br_056000,br_057600,br_115200,br_128000,br_230400,br_256000,
                 br_460800,br_921600);
  TDataBits   = (db_4,db_5,db_6,db_7,db_8);
  TParityBit  = (none,odd,even,mark,space);
  TStopBits   = (sb_1,sb_15,sb_2);

  // TSerial-Konfigurationsdatensatz
  TSerialConfig = record
    Valid : boolean;             // true: Parameter sind gltig
    COMPort : integer;           // Schnittstelle
    Baudrate : TBaudrate;        // bertragungsrate
    DataBits : TDataBits;        // Anzahl datenbits
    ParityBit : TParityBit;      // Parittsbit
    StopBits : TStopBits;        // Anzahl Stoppbits
    BufSizeTrm : integer;        // Gre des Sendepuffers
    BufSizeRec : integer;        // Gre des Empfangspuffers
    HandshakeRtsCts : boolean;   // Hardwire-Handshake RTS/CTS
    HandshakeDtrDsr : boolean;   // Hardwire-Handshake DTR/DSR
    HandshakeXOnXOff : boolean;  // Handshake XOn/XOff-Protokoll
    RTSActive : boolean;         // RTS-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    DTRActive : boolean;         // DTR-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    XOnChar : char;              // XOn-Zeichen
    XOffChar : char;             // XOff-Zeichen
    XOffLimit : integer;         // XOff-Limit
    XOnLimit : integer;          // XOn-Limit
    ErrorChar : char;            // Fehlerersatzzeichen
    EofChar : char;              // EOF-Zeichen
    EventChar : char;            // Ereigniszeichen
    ContinueOnXOff : boolean;    // bertragung fortsetzen auch bei XOff
    UseErrorChar : boolean;      // Fehlerersatzzeichen verwenden
    EliminateNullChar : boolean; // Nullzeichen entfernen
    AbortOnError : boolean;      // bei Fehler abbrechen
    RecTimeOut : integer;        // Timeout (ms) fr Datenempfang (0=kein Timeout)
    TrmTimeOut : integer;        // Timeout (ms) fr Datenbertragung (0=kein Timeout)
  end { record };

  // fr den internen Gebrauch
  TCOMExtParams = record
    APort : integer;
    ADCB : TDCB;
    ABufSizeR,
    ABufSizeT : integer;
    APosition : TPosition;
    ALeft,
    ATop : integer;
    AParent: TWinControl;
  end;

  TSerial = class;
  // Thread fr Datenbertragung im Hintergrund (von TSerial bentigt)
  TSerThread = class(TThread)
    constructor Create(SerComp : TSerial);
    procedure Execute;  override;
  private
    {$IFDEF OLDDELPHI}
    Event : integer;
    {$ELSE}
    Event : cardinal;
    {$ENDIF}
    Serial : TSerial;
    procedure EventHandling;
  end;

  // Thread fr Handshake-Eingnge (von TSerPort bentigt)
  TSerPort = class;
  TSerPortThread = class(TThread)
    constructor Create(SerComp : TSerPort);
    procedure Execute;  override;
  private
    Serial : TSerPort;
  end;

  // --- Basiskomponente TCustomSerial ---
  TCustomSerial = class(TComponent)
  private
  protected
    FActive            : boolean;          // true: Schnittstelle geffnet/ffnen
    FPorts             : TStringList;      // vorhandene Schnittstellen ('COM1',...)
    FCOMPort           : integer;          // zu ffnende Schnittstelle (1..), 0 wenn keine vorhanden
    FSerHandle         : THandle;          // Handle der geffneten Schnittstelle
    FBufSizeTrm        : integer;          // Gre des Sendepuffers
    FBufSizeRec        : integer;          // Gre des Empfangspuffers
    FThreadPriority    : TThreadPriority;  // Prioritt des im Hintergrund laufenden Thread
    Overlapped         : TOverlapped;      // bentigter Overlapped-Record
    dcb                : TDCB;             // Device Control Block
    procedure SetCOMPort(Value : integer); // Schnittstelle auswhlen
  public
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    destructor  Destroy; override;                     // Destruktor
    property SerHandle : THandle read FSerHandle;                               // Schnittstellen-Handle
  published
    property Ports : TStringList read FPorts;                                   // Liste der verfgbaren Schnittstellen
    property COMPort : integer read FCOMPort write SetCOMPort;                  // zu verwendende Schnittstelle (1..)
    property ThreadPriority : TThreadPriority read FThreadPriority write FThreadPriority;  // Prioritt des Thread
  end;

  // --- Komponente TSerial ---
  TRText = function : string of object;                                   // Textempfang
  {$IFDEF OLDDELPHI}
  TTData = function (var Data; DataSize : integer) : integer of object;   // Daten senden
  TRData = function (var Buf; BufSize : integer) : integer of object;     // Datenempfang
  TTText = function (s : string) : integer of object;                     // Text senden
  {$ELSE}
  TTData = function (var Data; DataSize : cardinal) : cardinal of object; // Daten senden
  TRData = function (var Buf; BufSize : cardinal) : cardinal of object;   // Datenempfang
  TTText = function (s : string) : cardinal of object;                    // Text senden
  {$ENDIF}

  TSerial = class(TCustomSerial)
  private
    { Private-Deklarationen }
    IsNT               : boolean;          // true, wenn Windows NT vorliegt
    FBaudrate          : TBaudrate;        // bertragungsrate
    FDataBits          : TDataBits;        // Anzahl Datenbits
    FParityBit         : TParityBit;       // Parittsbit
    FStopBits          : TStopBits;        // Anzahl Stopp-Bits
    FHandshakeRtsCts   : boolean;          // true: Hardwire-Handshake RTS/CTS
    FHandshakeDtrDsr   : boolean;          // true: Hardwire-Handshake DTR/DSR
    FHandshakeXOnXOff  : boolean;          // true: Handshake nach XOn/XOff-Protokoll
    FRTSActive         : boolean;          // true: RTS-Leitung aktiv (wenn nicht fr Handshake verwendet)
    FDTRActive         : boolean;          // true: DTR-Leitung aktiv (wenn nicht fr Handshake verwendet)
    FXOnChar           : char;             // XOn-Zeichen
    FXOffChar          : char;             // XOff-Zeichen
    FXOffLimit         : integer;          // XOff-Limit (nicht grer als FBufSizeRec)
    FXOnLimit          : integer;          // XOn-Limit (nicht grer als XOff-Limit)
    FErrorChar         : char;             // Fehlerersatzzeichen (wenn UseErrorChar)
    FEofChar           : char;             // End-Of-File-Zeichen
    FEventChar         : char;             // Ereignis-Zeichen
    FParityCheck       : boolean;          // true: Parittsprfung (Parittsbit einstellen!)
    FContinueOnXOff    : boolean;          // true: bertragung auch bei XOff fortsetzen
    FUseErrorChar      : boolean;          // true: Fehlerersatzzeichen verwenden
    FEliminateNullChar : boolean;          // true: Null-Zeichen entfernen
    FAbortOnError      : boolean;          // true: Bei Fehler abbrechen
    FRecTimeOut,                           // Timeout (ms) fr Datenempfang (0=kein Timeout)
    FTrmTimeOut        : integer;          // Timeout (ms) fr datenbertragung (0=kein Timeout)
    FSyncEventHandling : boolean;          // true: Ereignisbehandlung erfolgt Thread-synchronisiert
    FEnableEvents      : boolean;          // false: Schnittstellenereignisse werden ignoriert
    FOnBreak           : TNotifyEvent;     // UART-Ereignis EV_BREAK
    FOnCts             : TNotifyEvent;     // UART-Ereignis EV_CTS
    FOnDsr             : TNotifyEvent;     // UART-Ereignis EV_DSR
    FOnError           : TNotifyEvent;     // UART-Ereignis EV_ERROR
    FOnRing            : TNotifyEvent;     // UART-Ereignis EV_RING
    FOnDcd             : TNotifyEvent;     // UART-Ereignis EV_RLSD
    FOnRxChar          : TNotifyEvent;     // UART-Ereignis EV_RXCHAR
    FOnEventChar       : TNotifyEvent;     // UART-Ereignis EV_RXFLAG
    FOnTxEmpty         : TNotifyEvent;     // UART-Ereignis EV_TXEMPTY
    SerThread          : TSerThread;       // Thread fr Datentransfer im Hintergrund
    procedure SetActive(Value : boolean);      // ffnen/schlieen
    procedure SetParityBit(Value : TParityBit);// Parittsbit setzen
    procedure SetBufSizeTrm(Value : integer);  // Gre des Sendepuffers setzen
    procedure SetBufSizeRec(Value : integer);  // Gre des Empfangspuffers setzen
    procedure SetXOffLimit(Value : integer);   // XOff-Limit setzen
    procedure SetXOnLimit(Value : integer);    // XOn-Limit setzen
    procedure SetRecTimeOut(Value : integer);  // Timeout beim Empfang
    procedure SetTrmTimeOut(Value : integer);  // Timeout beim Senden
    function GetBufTrm : integer;              // Anzahl Zeichen, die sich noch im Sendepuffer befinden
    function GetBufRec : integer;              // Anzahl Zeichen, die sich im Empfangspuffer befinden
    function OpenIt : boolean;                 // Schnittstelle ffnen, Thread starten
    procedure CloseIt;                         // Schnittstelle schlieen, Thread beenden
    procedure DataInBuffer(var InQueue, OutQueue : integer);  // Ermitteln, wieviele Zeichen sind im Sende-/Empfangspuffer befinden
    function RText_00 : string; virtual;                                   // Text empfangen
    function RText_95 : string; virtual;
    function RText_NT : string; virtual;
    {$IFDEF OLDDELPHI}
    function TData_00(var Data; DataSize : integer) : integer; virtual;    // Daten senden (Dummy)
    function TData_95(var Data; DataSize : integer) : integer; virtual;    // Daten senden (Win 95/98)
    function TData_NT(var Data; DataSize : integer) : integer; virtual;    // Daten senden (Win NT)
    function RData_00(var Buf; BufSize : integer) : integer; virtual;      // Daten empfangen
    function RData_95(var Buf; BufSize : integer) : integer; virtual;
    function RData_NT(var Buf; BufSize : integer) : integer; virtual;
    function TText_00(s : string) : integer; virtual;                      // Text senden
    function TText_95(s : string) : integer; virtual;
    function TText_NT(s : string) : integer; virtual;
    {$ELSE}
    function TData_00(var Data; DataSize : cardinal) : cardinal; virtual;
    function TData_95(var Data; DataSize : cardinal) : cardinal; virtual;
    function TData_NT(var Data; DataSize : cardinal) : cardinal; virtual;
    function RData_00(var Buf; BufSize : cardinal) : cardinal; virtual;
    function RData_95(var Buf; BufSize : cardinal) : cardinal; virtual;
    function RData_NT(var Buf; BufSize : cardinal) : cardinal; virtual;
    function TText_00(s : string) : cardinal; virtual;
    function TText_95(s : string) : cardinal; virtual;
    function TText_NT(s : string) : cardinal; virtual;
    {$ENDIF}
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    TransmittData : TTData;  // Daten senden
    ReceiveData : TRData;    // Daten empfangen
    TransmittText : TTText;  // Text senden
    ReceiveText : TRText;    // Text empfangen
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    destructor  Destroy; override;                     // Destruktor
    function OpenComm : boolean; virtual;   // Schnittstelle ffnen
    procedure CloseComm; virtual;           // Schnittstelle schlieen
    function Purge(TxAbort,RxAbort,TxClear,RxClear : boolean) : boolean;        // bertragung abbrechen, Puffer lschen
    procedure SetConfig(SerialConfig : TSerialConfig); virtual;                 // Einstellungen setzen
    function GetConfig : TSerialConfig; virtual;                                // Einstellungen ermitteln
    function ConfigToStr(SerialConfig : TSerialConfig) : string; virtual;       // Konfigurationsdaten in String umwandeln
    function StrToConfig(CfgStr : string) : TSerialConfig; virtual;             // Konfigurationsstring in Record umwandeln
    property BufTrm : integer read GetBufTrm;                                   // Anzahl Zeichen im Sendepuffer
    property BufRec : integer read GetBufRec;                                   // Anzahl Zeichen im Empfangspuffer
  published
    { Published-Deklarationen }
    // Eigenschaften
    property Active : boolean read FActive write SetActive;                     // Schnittstelle ffnen/schlieen
    property Baudrate : TBaudrate read FBaudrate write FBaudrate;               // bertragungsrate
    property DataBits : TDataBits read FDataBits write FDataBits;               // Anzahl datenbits
    property ParityBit : TParityBit read FParityBit write SetParityBit;           // Parittsbit
    property StopBits : TStopBits read FStopBits write FStopBits;               // Anzahl Stoppbits
    property BufSizeTrm : integer read FBufSizeTrm write SetBufSizeTrm;         // Gre des Sendepuffers
    property BufSizeRec : integer read FBufSizeRec write SetBufSizeRec;         // Gre des Empfangspuffers
    property HandshakeRtsCts : boolean read FHandshakeRtsCts write FHandshakeRtsCts;     // Hardwire-Handshake RTS/CTS
    property HandshakeDtrDsr : boolean read FHandshakeDtrDsr write FHandshakeDtrDsr;     // Hardwire-Handshake DTR/DSR
    property HandshakeXOnXOff : boolean read FHandshakeXOnXOff write FHandshakeXOnXOff;  // Handshake XOn/XOff-Protokoll
    property RTSActive : boolean read FRTSActive write FRTSActive;              // RTS-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    property DTRActive : boolean read FDTRActive write FDTRActive;              // DTR-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    property XOnChar : char read FXOnChar write FXOnChar;                       // XOn-Zeichen
    property XOffChar : char read FXOffChar write FXOffChar;                    // XOff-Zeichen
    property XOffLimit : integer read FXOffLimit write SetXOffLimit;            // XOff-Limit
    property XOnLimit : integer read FXOnLimit write SetXOnLimit;               // XOn-Limit
    property ErrorChar : char read FErrorChar write FErrorChar;                 // Fehlerersatzzeichen
    property EofChar : char read FEofChar write FEofChar;                       // EOF-Zeichen
    property EventChar : char read FEventChar write FEventChar;                 // Ereigniszeichen
    property ParityCheck : boolean read FParityCheck;                           // Parittsprfung verwenden
    property ContinueOnXOff : boolean read FContinueOnXOff write FContinueOnXOff;  // bertragung fortsetzen auch bei XOff
    property UseErrorChar : boolean read FUseErrorChar write FUseErrorChar;     // Fehlerersatzzeichen verwenden
    property EliminateNullChar : boolean read FEliminateNullChar write FEliminateNullChar;  // Nullzeichen entfernen
    property AbortOnError : boolean read FAbortOnError write FAbortOnError;     // bei Fehler abbrechen
    property RecTimeOut : integer read FRecTimeOut write SetRecTimeOut;         // Timeout (ms) fr Datenempfang (0=kein Timeout)
    property TrmTimeOut : integer read FTrmTimeOut write SetTrmTimeOut;         // Timeout (ms) fr Datenbertragung (0=kein Timeout)
    property SyncEventHandling : boolean read FSyncEventHandling write FSyncEventHandling;  // true: Ereignisbehandlung ber Synchronize-Aufruf
    property EnableEvents : boolean read FEnableEvents write FEnableEvents;     // false: Schnittstellenereignisse (vorbergehend) ignorieren
    // Ereignisse
    property OnBreak : TNotifyEvent read FOnBreak write FOnBreak;               // UART-Ereignis EV_BREAK
    property OnCts : TNotifyEvent read FOnCts write FOnCts;                     // UART-Ereignis EV_CTS
    property OnDsr : TNotifyEvent read FOnDsr write FOnDsr;                     // UART-Ereignis EV_DSR
    property OnError : TNotifyEvent read FOnError write FOnError;               // UART-Ereignis EV_ERROR
    property OnRing : TNotifyEvent read FOnRing write FOnRing;                  // UART-Ereignis EV_RING
    property OnDcd : TNotifyEvent read FOnDcd write FOnDcd;                     // UART-Ereignis EV_RLSD
    property OnRxChar : TNotifyEvent read FOnRxChar write FOnRxChar;            // UART-Ereignis EV_RXCHAR
    property OnEventChar : TNotifyEvent read FOnEventChar write FOnEventChar;   // UART-Ereignis EV_RXFLAG
    property OnTxEmpty : TNotifyEvent read FOnTxEmpty write FOnTxEmpty;         // UART-Ereignis EV_TXEMPTY
  end;

  // --- Komponente TSerPort ---
  TSerPort = class(TCustomSerial)
  private
    FOut_DTR : boolean;
    FOut_RTS : boolean;
    FIn_DCD,
    FIn_DSR,
    FIn_CTS,
    FIn_RI   : boolean;
    FOnCts             : TNotifyEvent;     // UART-Ereignis EV_CTS
    FOnDsr             : TNotifyEvent;     // UART-Ereignis EV_DSR
    FOnRing            : TNotifyEvent;     // UART-Ereignis EV_RING
    FOnDcd             : TNotifyEvent;     // UART-Ereignis EV_RLSD
    FPollingMode       : boolean;          // Betrieb im Polling Mode (kein IRQ erforderlich)
    IsPolling          : boolean;
    SerPortThread          : TSerPortThread;   // Thread fr Datentransfer im Hintergrund
    procedure SetActive(Value : boolean);      // ffnen/schlieen
    procedure SetOutDtr(Value : boolean);      // DTR-Ausgang
    procedure SetOutRts(Value : boolean);      // RTS-Ausgang
    function GetInDCD : boolean;               // DCD-Eingang
    function GetInDSR : boolean;               // DSR-Eingang
    function GetInCTS : boolean;               // CTS-Eingang
    function GetInRI : boolean;                // RI-Eingang
    function OpenIt : boolean;                 // Schnittstelle ffnen, Thread starten
    procedure CloseIt;                         // Schnittstelle schlieen, Thread beenden
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    destructor  Destroy; override;                     // Destruktor
    function OpenComm : boolean; virtual;   // Schnittstelle ffnen
    procedure CloseComm; virtual;           // Schnittstelle schlieen
  published
    // Eigenschaften
    property Active : boolean read FActive write SetActive;                     // Schnittstelle ffnen/schlieen
    property Out_DTR : boolean read FOut_DTR write SetOutDtr;
    property Out_RTS : boolean read FOut_RTS write SetOutRts;
    property In_DCD : boolean read GetInDCD;
    property In_DSR : boolean read GetInDSR;
    property In_CTS : boolean read GetInCTS;
    property In_RI : boolean read GetInRI;
    property PollingMode : boolean read FPollingMode write FPollingMode;
    // Ereignisse
    property OnCts : TNotifyEvent read FOnCts write FOnCts;                     // UART-Ereignis EV_CTS
    property OnDsr : TNotifyEvent read FOnDsr write FOnDsr;                     // UART-Ereignis EV_DSR
    property OnRing : TNotifyEvent read FOnRing write FOnRing;                  // UART-Ereignis EV_RING
    property OnDcd : TNotifyEvent read FOnDcd write FOnDcd;                     // UART-Ereignis EV_RLSD
  end;

  // --- Formular: Dialog fr Schnittstellenauswahl ---
  TFormSerSel = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    ButtonOk: TButton;
    ButtonCancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private-Deklarationen }
    PortsAvail : boolean;  // true, wenn mindestens eine Schnittstelle vorhanden ist
  public
    { Public-Deklarationen }
    CurPort : integer;  // Aktuell ausgewhlte Schnittstelle
  end;

  // --- Komponente TSerSel ---
  TSerSel = class(TComponent)
  private
    { Private-Deklarationen }
    FSerial  : TCustomSerial;
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    function Execute : boolean;  // Dialog zur Schnittstellenauswahl darstellen
  published
    { Published-Deklarationen }
    // Eigenschaften
    property Serial : TCustomSerial read FSerial write FSerial;  // Komponente serielle Schnittstelle
  end;
  // --- Komponente TSerStdDlg ---
  TSerStdDlg = class(TComponent)
  private
    { Private-Deklarationen }
    FSerial  : TSerial;
    cc : TCommConfig;
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    function Execute : boolean;  // Dialog anzeigen
  published
    { Published-Deklarationen }
    // Eigenschaften
    property Serial : TSerial read FSerial write FSerial;  // zugeordnete Komponente
  end;

  // --- Komponente TFormCOMSetup ---
  TFormCOMSetup = class(TForm)
    Label1: TLabel;
    ComboBoxPort: TComboBox;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    ComboBoxBaudrate: TComboBox;
    Label3: TLabel;
    ComboBoxDatabit: TComboBox;
    Label4: TLabel;
    ComboBoxParity: TComboBox;
    Label5: TLabel;
    ComboBoxStop: TComboBox;
    GroupBox2: TGroupBox;
    CheckBoxRTSCTS: TCheckBox;
    CheckBoxDTRDSR: TCheckBox;
    CheckBoxSoft: TCheckBox;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    EditBufR: TEdit;
    UpDown1: TUpDown;
    Label7: TLabel;
    EditBufT: TEdit;
    UpDown2: TUpDown;
    ButtonAbort: TButton;
    ButtonOk: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonAbortClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private-Deklarationen }
    LastPort, LastBaud, LastData, LastParity, LastStop, LastBufR, LastBufT : integer;
    LastCTS, LastDSR, LastSoft : boolean;
  public
    { Public-Deklarationen }
    UsedPort : integer;             // verwendete Schnittstelle (0=COM1)
    BufSizeR, BufSizeT : integer;   // Gren Empfangs- und Sendepuffer
    dcb : TDCB;                     // DCB, dessen Inhalt durch diesen Dialog festgelegt wird
    function CommConfigDialogEx(var COMExtParams : TCOMExtParams) : boolean;  // Einstiegsroutine zur Darstellung des Dialoges
  end;

  // --- Komponente TSerExtDlg ---
  TSerExtDlg = class(TComponent)
  private
    { Private-Deklarationen }
    FSerial  : TSerial;
    dcb : TDCB;
    FPositionDlg : TPosition;
    FLeftDlg,
    FTopDlg : integer;
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;  // Konstruktor
    function Execute : boolean;  // Dialog anzeigen
  published
    { Published-Deklarationen }
    // Eigenschaften
    property Serial : TSerial read FSerial write FSerial;  // zugeordnete Komponente
    property PositionDlg : TPosition read FPositionDlg write FPositionDlg;  // Positionsart des Dialoges
    property LeftDlg : integer read FLeftDlg write FLeftDlg;  // Position des Dialoges (Position=poDesigned)
    property TopDlg : integer read FTopDlg write FTopDlg;
  end;

  // --- Komponente TComComboBox ---
  TCOMComboBox = class(TCustomComboBox)
  private
    FSerial : TCustomSerial;
    procedure SetSelectedPort(Value : integer);
    function  GetSelectedPort : integer;
  protected
    { Protected-Deklarationen }
    procedure Change; override;  // Auswahl hat sich gendert
  public
    constructor Create(AOwner: TComponent); override;  // Konstruktor
  published
    property Serial : TCustomSerial read FSerial write FSerial;  // zugeordnete Komponente
    property SelectedPort : integer read GetSelectedPort write SetSelectedPort;  // ausgewhlte Schnittstelle
    property Enabled;      // Komponente ist ansprechbar
    property Font;         // Schriftart
    property ShowHint;     // Hinweis anzeigen
    property Visible;      // sichtbar
    property OnChange;     // Ereignis: Auswahl ndert sich
    property OnDropDown;   // Ereignis: ComboBox wird herunter geklappt
  end;

var
  // Instanzen der verwendeten Formulare
  FormSerSel : TFormSerSel;
  FormCOMSetup: TFormCOMSetup;

function LastCOM : integer;
// Liefert die Nummer der letzten COM-Schnittstelle, deren Existenz geprft
// wird. Das Ergebnis ist immer MaxPort+1 (=4).

function COMAvailable(COMPort : integer) : boolean;
// Mit dieser Funktion wird ermittelt, ob die angegebene Schnittstelle
// existiert.
// COMPort: Abzufragende Schnittstelle (1=COM1)
// Ergebnis: true, wenn Schnittstelle existiert

procedure Register;

implementation

{$R FORMSSEL.DFM}
{$R DLGCOM.DFM}

type
  // Flags von dcb.Flags
  TDCBFlag = (fBinary,fParity,fOutxCtsFlow,fOutxDsrFlow,fDtrControl,Dummy1,
              fDsrSensitivity,fTXContinueOnXoff,fOutX,fInX,fErrorChar,
              fNull,fRtsControl,Dummy2,fAbortOnError);

const
  MaxPort = 3;  { es wird bis COM4 geprft }
  Baudrates : array[0..19] of integer =
    (50,CBR_110,150,CBR_300,CBR_600,CBR_1200,CBR_2400,CBR_4800,
     CBR_9600,CBR_14400,CBR_19200,CBR_38400,CBR_56000,
     CBR_57600,CBR_115200,CBR_128000,230400,CBR_256000,460800,921600);
  ParityNames : array[0..4] of string =
    ('none','odd','even','mark','space');
  StopbitsNames : array[0..2] of string =
    ('1','1,5','2');
  SerCfgID  : array[0..3] of char = 'RRS0';  // ID fr Konfigurationsstring TSerial (Version 0)

var
  AvailPorts : array[0..MaxPort] of boolean;  // vorhandene Schnittstellen (COM1... = true)
  PortNames  : array[0..MaxPort] of integer;  // Nummern (1..) der vorhandenen Schnittstellen
  PortsExist : boolean;  // true: mind. eine Schnittstelle ist vorhanden

(*** Allgemein ***)

function LastCOM : integer;
begin
  Result:=MaxPort+1;
end;

function COMAvailable(COMPort : integer) : boolean;
begin
  dec(COMPort);
  if (COMPort>=0) and (COMPort<=MaxPort) then
    Result:=AvailPorts[COMPort]
  else Result:=false;
end;

procedure CheckSerPorts;
// Prft, welche seriellen Schnittstellen vorhanden sind
// Ergebnis wird in AvailPorts und PortsExist abgelegt
var
  s : array[0..7] of char;
  {$IFDEF OLDDELPHI}
  i, j, k : integer;
  {$ELSE}
  i, j, k : cardinal;
  {$ENDIF}
  CommConfig : TCommConfig;
begin
  PortsExist:=false;
  s:='COMx'+#0+#0;
  i:=SizeOf(CommConfig);
  k:=0;
  for j:=0 to MaxPort do
  begin
    if j<9 then
      s[3]:=chr($31+j)
    else
    begin
      s[3]:=chr($30+((j+1) div 10));
      s[4]:=chr($30+((j+1) mod 10));
    end;
    AvailPorts[j]:=GetDefaultCommConfig(s,CommConfig,i);
    PortNames[j]:=0;
    if AvailPorts[j] then
    begin
      PortNames[k]:=j+1;
      inc(k);
    end;
    PortsExist:=PortsExist or AvailPorts[j];
  end;
end;

function Port2Index(Value : integer) : integer;
// Schnittstelle -> ItemIndex fr ComboBox vorhandener Schnittstellen
// Die Wahl einer nicht vorhandenen Schnittstelle wird ignoriert
var
  ii : integer;
begin
  Result:=0;
  if (Value>0) and (Value<=MaxPort+1) then
  begin
    if AvailPorts[Value-1] then
    begin  // angegebene Schnittstelle existiert
      for ii:=0 to MaxPort do  // Schnittstelle -> ItemIndex
        if PortNames[ii]=Value then Result:=ii;
    end;
  end;
end;

function GetDCBFlag(ADCB : TDCB; AFlag : TDCBFlag) : integer;
// Ermittelt den Zustand eines Flags von DCB.Flags
begin
  Result:=ADCB.Flags shr (ord(AFlag));
  if (AFlag=fDtrControl) or (AFlag=fRtsControl) then Result:=Result and $3
                                                else Result:=Result and $1;
end;

procedure SetDCBFlag(var ADCB : TDCB; AFlag : TDCBFlag; Value : integer);
// Flag in DCB.Flags setzen
var
  i : integer;
begin
  if (AFlag=fDtrControl) or (AFlag=fRtsControl) then Value:=Value and $3
                                                else Value:=Value and $1;
  i:=Value shl (ord(AFlag));
  ADCB.Flags:=ADCB.Flags and (i xor -1);  // Flag lschen
  ADCB.Flags:=ADCB.Flags or i;  // Flag entsprechend setzen
end;

(*** TCustomSerial ***)

constructor TCustomSerial.Create(AOwner: TComponent);
// Konstruktor
var
  j : integer;
begin
  inherited Create(AOwner);
  FActive:=false;                    // geschlossen
  FSerHandle:=INVALID_HANDLE_VALUE;  // ungltiges Handle
  FBufSizeTrm:=2048;                 // Gre des Sendepuffers
  FBufSizeRec:=2048;                 // Gre des Empfangspuffers
  // vorhandene Schnittstellen bernehmen
  FPorts:=TStringList.Create;
  FPorts.Clear;
  for j:=0 to MaxPort do
    if AvailPorts[j] then FPorts.Add('COM'+IntToStr(j+1));
  if PortsExist then
  begin
    for j:=MaxPort downto 0 do
      if AvailPorts[j] then FCOMPort:=j+1;   // default: niedrigste verfgbare Schnittstelle
  end
  else FCOMPort:=0;  // keine Schnittstelle vorhanden
end;

destructor TCustomSerial.Destroy;
// Destruktor
begin
  FPorts.Free;
  inherited Destroy;
end;

procedure TCustomSerial.SetCOMPort(Value : integer);
// Zu verwendende Schnittstelle festlegen
// Value=1 -> COM1
// Nicht vorhandene Schnittstelle wird nicht akzeptiert
// Value=0 -> keine Schnittstelle
begin
  if (Value>=0) and (Value<=MaxPort+1) then
  begin
    FCOMPort:=0;
    if PortsExist and (Value>0) then
    begin
      if AvailPorts[Value-1] then FCOMPort:=Value;
    end;
  end;
end;

(*** TSerThread ***)

constructor TSerThread.Create;
// Konstruktor des Thread
// Thread wird nur angelegt, wenn mind. eine Ereignismethode deklariert ist.
begin
  inherited Create(false);
  Serial:=SerComp;
  Priority:=Serial.ThreadPriority;
  FreeOnTerminate:=true;
end;

procedure TSerThread.EventHandling;
// Behandlung von Schnittstellenereignissen, Aufruf der zugeordneten
// Behandlungsroutinen.
begin
  if Serial.EnableEvents then
  begin
    if (Event and EV_BREAK)>0 then Serial.OnBreak(Serial);
    if (Event and EV_CTS)>0 then Serial.OnCts(Serial);
    if (Event and EV_DSR)>0 then Serial.OnDsr(Serial);
    if (Event and EV_ERR)>0 then Serial.OnError(Serial);
    if (Event and EV_RING)>0 then Serial.OnRing(Serial);
    if (Event and EV_RLSD)>0 then Serial.OnDcd(Serial);
    if (Event and EV_RXCHAR)>0 then Serial.OnRxChar(Serial);
    if (Event and EV_RXFLAG)>0 then Serial.OnEventChar(Serial);
    if (Event and EV_TXEMPTY)>0 then Serial.OnTxEmpty(Serial);
  end;
end;

procedure TSerThread.Execute;
// Thread-Routine, wartet auf Schnittstellenereignisse
begin
  // Thread-Routine, wird beim Start des Thread durchlaufen
  while (not Terminated) do
  begin
    if WaitCommEvent(Serial.SerHandle,Event,nil) then
    begin
      if Serial.SyncEventHandling then
        Synchronize(EventHandling)  // An der Schnittstelle ist vorgegebenes Ereignis aufgetreten
      else
        EventHandling;  // dito ohne Thread-Synchronisation (bessere Performance)
    end;
  end;
end;

(*** TSerial ***)

constructor TSerial.Create(AOwner: TComponent);
// Konstruktor
var
  VerInfo : TOSVersionInfo;
begin
  inherited Create(AOwner);
  // Betriebssystemplattform ermitteln
  IsNT:=false;
  VerInfo.dwOSVersionInfoSize:=sizeof(VerInfo);
  if (GetVersionEx(VerInfo)) then
    IsNT:=VerInfo.dwPlatformId=VER_PLATFORM_WIN32_NT;
  // Grundeinstellungen
  FBaudrate:=br_009600;              // 9600 Baud
  FDataBits:=db_8;                   // 8 Datenbit
  FBufSizeTrm:=2048;                 // 2048 Byte Sendepuffergre
  FBufSizeRec:=2048;                 // 2048 Byte Empfangspufergre
  FHandshakeRtsCts:=false;           // kein Handshake
  FHandshakeDtrDsr:=false;
  FHandshakeXOnXOff:=false;
  FRTSActive:=false;
  FDTRActive:=false;
  FXOnChar:=#17;                     // XOn-Zeichen
  FXOffChar:=#19;                    // XOff-zeichen
  FXOffLimit:=1600;                  // XOff-Limit
  FXOnLimit:=400;                    // XOn-Limit
  FErrorChar:='?';                   // Fehlerersatzzeichen
  FEofChar:=#$1A;                    // EOF-Zeichen (^Z)
  FEventChar:=#$0D;                  // Ereigniszeichen
  FParityCheck:=false;               // Parittsprfung
  FContinueOnXOff:=false;            // weiter senden trotz XOff
  FUseErrorChar:=false;              // Fehlerersatzzeichen verwenden
  FEliminateNullChar:=false;         // Nullzeichen entfernen
  FAbortOnError:=false;              // bei Fehler abbrechen
  FThreadPriority:=tpNormal;         // Thread-Prioritt
  FSyncEventHandling:=false;         // keine Thread-Synchronisierung bei Ereignisbehandlung
  FEnableEvents:=true;               // Ereignisse behandeln
end;

destructor TSerial.Destroy;
// Destruktor
begin
  CloseIt;  // Schnittstelle schlieen
  inherited Destroy;
end;

function TSerial.OpenIt : boolean;
// Schnittstelle ffnen
var
  i : integer;
  c : array[0..63] of char;
  ctmo : TCommTimeOuts;
  b : boolean;
begin
  Result:=false;
  if (not FActive) and (COMPort>0) then
  begin
    // Schnittstelle ffnen
    c:='COMx'+#0+#0;
    if FCOMPort<10 then c[3]:=chr($30+FCOMPort)
    else
    begin
      c[3]:=chr($30+(FCOMPort div 10));
      c[4]:=chr($30+(FCOMPort mod 10));
    end;
    FSerHandle:=CreateFile(c,
      GENERIC_READ or GENERIC_WRITE,
      0,
      nil,
      OPEN_EXISTING,
      FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,
      0);
    if (FSerHandle<>INVALID_HANDLE_VALUE) then
    begin  // Overlapped-Struktur initialisieren
      with Overlapped do
      begin
        Internal:=0;
        InternalHigh:=0;
        Offset:=0;
        OffsetHigh:=0;
        hEvent:=0;
      end;
      // Puffergren festlegen
      if (not SetupComm(FSerHandle,BufSizeRec,BufSizeTrm)) then
      begin
        CloseHandle(FSerHandle);
        FSerHandle:=INVALID_HANDLE_VALUE;
      end;
    end;
    if (FSerHandle<>INVALID_HANDLE_VALUE) then
    begin  // Schnittstellen initialisieren (DCB)
      dcb.DCBLength:=SizeOf(TDCB);
      c:='baud=9600 parity=N data=8 stop=1'+#0;
      b:=BuildCommDCB(c,dcb);  // dcb
      if b then
      begin
        dcb.BaudRate:=Baudrates[ord(FBaudrate)];
        dcb.ByteSize:=ord(FDataBits)+4;    // number of bits/byte, 4-8
        dcb.Parity:=ord(FParityBit);       // 0-4=no,odd,even,mark,space
        dcb.StopBits:=ord(FStopBits);      // 0,1,2 = 1, 1.5, 2
        dcb.Flags:=1;  // fBinary
        dcb.Flags:=dcb.Flags or (ord(FParityCheck) shl 1); // fParity
        dcb.Flags:=dcb.Flags or (ord(FHandshakeRTSCTS) shl 2); // fOutxCtsFlow
        dcb.Flags:=dcb.Flags or (ord(FHandshakeDTRDSR) shl 3); // fOutxDsrFlow
        if FHandshakeDTRDSR then dcb.Flags:=dcb.Flags or (DTR_CONTROL_HANDSHAKE shl 4)
        else
        if FDTRActive then dcb.Flags:=dcb.Flags or (DTR_CONTROL_ENABLE shl 4)  // fDtrControl
        else dcb.Flags:=dcb.Flags or (DTR_CONTROL_DISABLE shl 4);  // fDtrControl
        // fDsrSensitivity=0
        dcb.Flags:=dcb.Flags or (ord (FContinueOnXOff) shl 7);  // fTXContinueOnXoff
        dcb.Flags:=dcb.Flags or (ord (FHandshakeXOnXOff) shl 8);  // fOutX
        dcb.Flags:=dcb.Flags or (ord (FHandshakeXOnXOff) shl 9);  // fInX
        dcb.Flags:=dcb.Flags or (ord (FUseErrorChar) shl 10);  // fErrorChar
        dcb.Flags:=dcb.Flags or (ord (FEliminateNullChar) shl 11);  // fNull
        if FHandshakeRTSCTS then dcb.Flags:=dcb.Flags or (RTS_CONTROL_HANDSHAKE shl 12)
        else
        if FRTSActive then dcb.Flags:=dcb.Flags or (RTS_CONTROL_ENABLE shl 12)  // fRtsControl
        else dcb.Flags:=dcb.Flags or (RTS_CONTROL_DISABLE shl 12);  // fRtsControl
        dcb.Flags:=dcb.Flags or (ord (FAbortOnError) shl 14);  // fAbortOnError
        // fDummy2=0
        dcb.XonChar:=FXOnChar;
        dcb.XoffChar:=FXOffChar;
        dcb.XOnLim:=FXOnLimit;
        dcb.XOffLim:=FXOffLimit;
        dcb.ErrorChar:=FErrorChar;
        dcb.EofChar:=FEofChar;
        dcb.EvtChar:=FEventChar;
      end;
      if b then b:=SetCommState(FSerHandle,dcb);
      if (not b) then
      begin  // Initialisierung fehlgeschlagen
        CloseHandle(FSerHandle);  // Schnittstelle schlieen
        FSerHandle:=INVALID_HANDLE_VALUE;
      end;
    end;
    if (FSerHandle<>INVALID_HANDLE_VALUE) and ((FRecTimeOut>0) or (FTrmTimeOut>0)) then
    with ctmo do
    begin  // Timeouts festlegen
      if FRecTimeOut>0 then
      begin
        ReadIntervalTimeout:=0;
        ReadIntervalTimeout:=FRecTimeOut;
        ReadTotalTimeoutMultiplier:=10000 div dcb.Baudrate;
        if ReadTotalTimeoutMultiplier=0 then ReadTotalTimeoutMultiplier:=1;
        ReadTotalTimeoutConstant:=FRecTimeOut;
      end
      else
      begin
        ReadIntervalTimeout:=0;
        ReadTotalTimeoutMultiplier:=0;
        ReadTotalTimeoutConstant:=0;
      end;
      if FTrmTimeOut>0 then
      begin
        WriteTotalTimeoutMultiplier:=10000 div dcb.Baudrate;
        if WriteTotalTimeoutMultiplier=0 then WriteTotalTimeoutMultiplier:=1;
        WriteTotalTimeoutConstant:=FTrmTimeOut;
      end
      else
      begin
        WriteTotalTimeoutMultiplier:=0;
        WriteTotalTimeoutConstant:=0;
      end;
      SetCommTimeOuts(FSerHandle,ctmo);
    end;
    i:=0;
    if (FSerHandle<>INVALID_HANDLE_VALUE) then
    begin  // Ereignismaske (wird entsprechend deklarierter Ereignisbehandlungsmethoden festgelegt)
      if Assigned(OnBreak) then i:=EV_BREAK;
      if Assigned(OnCts) then i:=i or EV_CTS;
      if Assigned(OnDsr) then i:=i or EV_DSR;
      if Assigned(OnError) then i:=i or EV_ERR;
      if Assigned(OnRing) then i:=i or EV_RING;
      if Assigned(OnDcd) then i:=i or EV_RLSD;
      if Assigned(OnRxChar) then i:=i or EV_RXCHAR;
      if Assigned(OnEventChar) then i:=i or EV_RXFLAG;
      if Assigned(OnTxEmpty) then i:=i or EV_TXEMPTY;
      if (not SetCommMask(FSerHandle,i)) then
      begin  // Fehler beim Setzen der Maske
        CloseHandle(FSerHandle);  // Schnittstelle schlieen
        FSerHandle:=INVALID_HANDLE_VALUE;
      end;
    end;
    SerThread:=nil;
    if (FSerHandle<>INVALID_HANDLE_VALUE) and (i<>0) then
    begin  // Thread erzeugen und starten, wenn mindestens ein Ereignis festgelegt ist
       SerThread:=TSerThread.Create(Self);  // Thread anlegen
       // SerThread.Priority:=ThreadPriority;  // wird in SerThread erledigt
    end;
    Result:=FSerHandle<>INVALID_HANDLE_VALUE;
    if Result then
    begin  // Plattformabhngige bertragungsfunktionen festlegen
      if IsNT then
      begin
        ReceiveData:=RData_NT;
        TransmittData:=TData_NT;
        ReceiveText:=RText_NT;
        TransmittText:=TText_NT;
      end
      else
      begin
        ReceiveData:=RData_95;
        TransmittData:=TData_95;
        ReceiveText:=RText_95;
        TransmittText:=TText_95;
      end;
    end
    else
    begin
      ReceiveData:=RData_00;
      TransmittData:=TData_00;
      ReceiveText:=RText_00;
      TransmittText:=TText_00;
    end;
    FActive:=Result;
  end;
end;

procedure TSerial.CloseIt;
// Schnittstelle schlieen
begin
  if FActive then
  begin
    if Assigned(SerThread) then
      SerThread.Terminate;  // Thread zum Beenden auffordern
    SetCommMask(FSerHandle,0);
    CloseHandle(FSerHandle);
    FSerHandle:=INVALID_HANDLE_VALUE;
    ReceiveData:=RData_00;
    TransmittData:=TData_00;
    ReceiveText:=RText_00;
    TransmittText:=TText_00;
    FActive:=false;
  end;
end;

procedure TSerial.DataInBuffer(var InQueue, OutQueue : integer);
// Anzahl Zeichen, die im Sende- und Empfangspuffer stehen
var
  ComStat : TComStat;
  {$IFDEF OLDDELPHI}
  e : integer;
  {$ELSE}
  e : cardinal;
  {$ENDIF}
begin
  InQueue:=0;
  OutQueue:=0;
  if FActive then
  begin
    if ClearCommError(FSerHandle,e,@ComStat) then
    begin
      InQueue:=ComStat.cbInQue;
      OutQueue:=ComStat.cbOutQue;
    end;
  end;
end;

procedure TSerial.SetActive(Value : boolean);
// Schnittstelle ffnen/schlieen
begin
  if Value and (not FActive) then FActive:=OpenIt  // ffnen
  else
  if (not Value) and FActive then CloseIt;  // schlieen
end;

procedure TSerial.SetParityBit(Value : TParityBit);
// Parittsbit setzen
begin
  FParityBit:=Value;
  FParityCheck:=Value>none;  // Flag fParity (DCB)
end;

procedure TSerial.SetBufSizeTrm(Value : integer);
// Gre des Sendepuffers festlegen
// Mindestgre 16 Byte
begin
  if Value<16 then Value:=16;
  FBufSizeTrm:=Value;
end;

procedure TSerial.SetBufSizeRec(Value : integer);
// Gre des Empfangspuffers festlegen
// Mindestgre 16 Byte
// XOff- und XOn-Limit werden bei Bedarf angepat
begin
  if Value<16 then Value:=16;
  FBufSizeRec:=Value;
  if FXOffLimit>Value then FXOffLimit:=Value;
  if FXOnLimit>=FXOffLimit then FXOnLimit:=FXOffLimit-1;
end;

procedure TSerial.SetXOffLimit(Value : integer);
// Oberer Fllgrad des Empfangspuffers, bei dem das XOff-Zeichen ausgegeben wird
// (XOn/XOff-Protokoll)
// Wert wird bei Bedarf korrigiert (nicht grer als Empfangspuffergre und
// nicht kleiner als XOn-Limit)
begin
  if Value<=FXOnLimit then Value:=FXOnLimit+1;
  if Value>FBufSizeRec then Value:=FBufSizeRec;
  FXOffLimit:=Value;
end;

procedure TSerial.SetXOnLimit(Value : integer);
// Unterer Fllgrad des Empfangspuffers, bei dem das XOn-Zeichen ausgegeben wird
// (XOn/XOff-Protokoll)
// Wert wird bei Bedarf korrigiert (nicht grer XOff-Limit und
// nicht kleiner als 0)
begin
  if Value>=FXOffLimit then Value:=FXOffLimit-1;
  if Value<0 then Value:=0;
  FXOnLimit:=Value;
end;

procedure TSerial.SetRecTimeOut(Value : integer);
// Timeout fr Datenempfang
begin
  if Value<0 then Value:=0;
  FRecTimeOut:=Value;
end;

procedure TSerial.SetTrmTimeOut(Value : integer);
// Timeout fr Datensendung
begin
  if Value<0 then Value:=0;
  FTrmTimeOut:=Value;
end;

function TSerial.GetBufTrm : integer;
// Anzahl Zeichenermitteln, die sich im Sendepuffer befinden
var
  i : integer;
begin
  DataInBuffer(i,Result);
end;

function TSerial.GetBufRec : integer;
// Anzahl Zeichenermitteln, die sich im Empfangspuffer befinden
var
  i : integer;
begin
  DataInBuffer(Result,i);
end;

function TSerial.OpenComm : boolean;
// Serielle Schnittstelle ffnen (public deklarierte Funktion)
// Alternative zur Eigenschaft Active
begin
  Result:=OpenIt;
end;

procedure TSerial.CloseComm;
// Serielle Schnittstelle schlieen (public deklarierte Funktion)
// Alternative zur Eigenschaft Active
begin
  CloseIt;
end;

function TSerial.Purge(TxAbort,RxAbort,TxClear,RxClear : boolean) : boolean;
// Inhalt des Sende-/Empfangspuffers lschen
// bertragung (senden/empfangen) abbrechen
// Die Funktion verwendet die API-Funktion PurgeComm
// Hinweis: Diese Funktion darf unter Win32s nicht aufgerufen werden!
// TxAbort=true -> Senden abbrechen
// RxAbort=true -> Empfang abbrechen
// TxClear=true -> Inhalt des Sendepuffers lschen
// RxClear=true -> Inhalt des Empfangspuffers lschen
// Ergebnis true, wenn Aktion erfolgreich ausgefhrt werden konnte
begin
  if FActive then
    Result:=PurgeComm(FSerHandle,ord(TxAbort) or
                                (ord(RxAbort) shl 1) or
                                (ord(TxClear) shl 2) or
                                (ord(RxClear) shl 3))
  else Result:=false;
end;

procedure TSerial.SetConfig(SerialConfig : TSerialConfig);
// Konfiguration aus Record in Eigenschaften bernehmen
// bernahme erfolgt nur, wenn SerialConfig.Valid=true
begin
  if SerialConfig.Valid then
  begin
    COMPort:=SerialConfig.COMPort;                     // Schnittstelle
    Baudrate:=SerialConfig.Baudrate;                   // bertragungsrate
    DataBits:=SerialConfig.DataBits;                   // Anzahl datenbits
    ParityBit:=SerialConfig.ParityBit;                 // Parittsbit
    StopBits:=SerialConfig.StopBits;                   // Anzahl Stoppbits
    BufSizeTrm:=SerialConfig.BufSizeTrm;               // Gre des Sendepuffers
    BufSizeRec:=SerialConfig.BufSizeRec;               // Gre des Empfangspuffers
    HandshakeRtsCts:=SerialConfig.HandshakeRtsCts;     // Hardwire-Handshake RTS/CTS
    HandshakeDtrDsr:=SerialConfig.HandshakeDtrDsr;     // Hardwire-Handshake DTR/DSR
    HandshakeXOnXOff:=SerialConfig.HandshakeXOnXOff;   // Handshake XOn/XOff-Protokoll
    RTSActive:=SerialConfig.RTSActive;                 // RTS-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    DTRActive:=SerialConfig.DTRActive;                 // DTR-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
    XOnChar:=SerialConfig.XOnChar;                     // XOn-Zeichen
    XOffChar:=SerialConfig.XOffChar;                   // XOff-Zeichen
    XOffLimit:=SerialConfig.XOffLimit;                 // XOff-Limit
    XOnLimit:=SerialConfig.XOnLimit;                   // XOn-Limit
    ErrorChar:=SerialConfig.ErrorChar;                 // Fehlerersatzzeichen
    EofChar:=SerialConfig.EofChar;                     // EOF-Zeichen
    EventChar:=SerialConfig.EventChar;                 // Ereigniszeichen
    ContinueOnXOff:=SerialConfig.ContinueOnXOff;       // bertragung fortsetzen auch bei XOff
    UseErrorChar:=SerialConfig.UseErrorChar;           // Fehlerersatzzeichen verwenden
    EliminateNullChar:=SerialConfig.EliminateNullChar; // Nullzeichen entfernen
    AbortOnError:=SerialConfig.AbortOnError;           // bei Fehler abbrechen
    RecTimeOut:=SerialConfig.RecTimeOut;               // Timeout (ms) fr Datenempfang (0=kein Timeout)
    TrmTimeOut:=SerialConfig.TrmTimeOut;               // Timeout (ms) fr Datenbertragung (0=kein Timeout)
  end;
end;

function TSerial.GetConfig : TSerialConfig;
// aktuelle Einstellungen als Funktionsergebnis zurck liefern
begin
  Result.Valid:=true;                          // Parameter sind gltig
  Result.COMPort:=COMPort;                     // Schnittstelle
  Result.Baudrate:=Baudrate;                   // bertragungsrate
  Result.DataBits:=DataBits;                   // Anzahl datenbits
  Result.ParityBit:=ParityBit;                 // Parittsbit
  Result.StopBits:=StopBits;                   // Anzahl Stoppbits
  Result.BufSizeTrm:=BufSizeTrm;               // Gre des Sendepuffers
  Result.BufSizeRec:=BufSizeRec;               // Gre des Empfangspuffers
  Result.HandshakeRtsCts:=HandshakeRtsCts;     // Hardwire-Handshake RTS/CTS
  Result.HandshakeDtrDsr:=HandshakeDtrDsr;     // Hardwire-Handshake DTR/DSR
  Result.HandshakeXOnXOff:=HandshakeXOnXOff;   // Handshake XOn/XOff-Protokoll
  Result.RTSActive:=RTSActive;                 // RTS-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
  Result.DTRActive:=DTRActive;                 // DTR-Ausgang aktiv setzen (wenn nicht zum Handshake benutzt)
  Result.XOnChar:=XOnChar;                     // XOn-Zeichen
  Result.XOffChar:=XOffChar;                   // XOff-Zeichen
  Result.XOffLimit:=XOffLimit;                 // XOff-Limit
  Result.XOnLimit:=XOnLimit;                   // XOn-Limit
  Result.ErrorChar:=ErrorChar;                 // Fehlerersatzzeichen
  Result.EofChar:=EofChar;                     // EOF-Zeichen
  Result.EventChar:=EventChar;                 // Ereigniszeichen
  Result.ContinueOnXOff:=ContinueOnXOff;       // bertragung fortsetzen auch bei XOff
  Result.UseErrorChar:=UseErrorChar;           // Fehlerersatzzeichen verwenden
  Result.EliminateNullChar:=EliminateNullChar; // Nullzeichen entfernen
  Result.AbortOnError:=AbortOnError;           // bei Fehler abbrechen
  Result.RecTimeOut:=RecTimeOut;               // Timeout (ms) fr Datenempfang (0=kein Timeout)
  Result.TrmTimeOut:=TrmTimeOut;               // Timeout (ms) fr Datenbertragung (0=kein Timeout)
end;

function TSerial.ConfigToStr(SerialConfig : TSerialConfig) : string;
// Konfigurationsdaten in String umwandeln
// Bei ungltigen Daten wird ein Leerstring zurck geliefert
var
  i : integer;
  r : array[0..127] of char;
  p : byte;

  procedure Int2RStr(Value, DefLength, Index : integer);
  // Integer -> String mit Nullen vorangestellt
  // Ergebnis wird ab r[Index] abgelegt
  var
    j : integer;
    s : string;
  begin
    s:=IntToStr(Value);
    while Length(s)<DefLength do s:='0'+s;
    for j:=1 to DefLength do r[Index+j-1]:=s[j];
  end;

  procedure Char2Str(AChar : char; Index : integer);
  // Wandelt Zeichenkode in 3-stelligen Dezimalstring um
  // Ergebnis wird ab r[Index] abgelegt
  var
    j : integer;
    s : string;
  begin
    s:=IntToStr(byte(AChar));
    while Length(s)<3 do s:='0'+s;
    for j:=1 to 3 do r[Index+j-1]:=s[j];
  end;

begin
  if SerialConfig.Valid then
  begin
    for i:=0 to SizeOf(r)-1 do r[i]:=#0;
    // ID und Version (0)
    for i:=0 to 3 do r[i]:=SerCfgID[i];
    // Schnittstelle (4)
    Int2RStr(SerialConfig.COMPort,3,4);
    // Baudrate (7)
    Int2RStr(ord(SerialConfig.Baudrate),2,7);
    // Datenbits (9)
    Int2RStr(ord(SerialConfig.DataBits),1,9);
    // ParityBit (10)
    Int2RStr(ord(SerialConfig.ParityBit),1,10);
    // StoppBits (11)
    Int2RStr(ord(SerialConfig.StopBits),1,11);
    // Sendepuffergre (12)
    Int2RStr(SerialConfig.BufSizeTrm,8,12);
    // Empfangspuffergre (20)
    Int2RStr(SerialConfig.BufSizeRec,8,20);
    // Handshake RTS/CTS (28)
    Int2RStr(ord(SerialConfig.HandshakeRtsCts),1,28);
    // Handshake DTR/DSR (29)
    Int2RStr(ord(SerialConfig.HandshakeDtrDsr),1,29);
    // Handshake XOn/XOff (30)
    Int2RStr(ord(SerialConfig.HandshakeXOnXOff),1,30);
    // RTS-Zustand (31)
    Int2RStr(ord(SerialConfig.RTSActive),1,31);
    // DTR-Zustand (32)
    Int2RStr(ord(SerialConfig.DTRActive),1,32);
    // XOn-Zeichen (33)
    Char2Str(SerialConfig.XOnChar,33);
    // XOff-Zeichen (36)
    Char2Str(SerialConfig.XOffChar,36);
    // XOff-Limit (39)
    Int2RStr(SerialConfig.XOffLimit,8,39);
    // XOn-Limit (47)
    Int2RStr(SerialConfig.XOnLimit,8,47);
    // Fehlerzeichen (55)
    Char2Str(SerialConfig.ErrorChar,55);
    // EOF-Zeichen (58)
    Char2Str(SerialConfig.EofChar,58);
    // Ereigniszeichen (61)
    Char2Str(SerialConfig.EventChar,61);
    // Continue On XOff (64)
    Int2RStr(ord(SerialConfig.ContinueOnXOff),1,64);
    // Fehlerzeichen verwenden (65)
    Int2RStr(ord(SerialConfig.UseErrorChar),1,65);
    // Nullzeichen entfernen (66)
    Int2RStr(ord(SerialConfig.EliminateNullChar),1,66);
    // Abbruch bei Fehler (67)
    Int2RStr(ord(SerialConfig.AbortOnError),1,67);
    // Empfangen TimeOut (68)
    Int2RStr(SerialConfig.RecTimeOut,10,68);
    // Senden TimeOut (78)
    Int2RStr(SerialConfig.TrmTimeOut,10,78);
    // String-Paritt (88) (3 Ziffern)
    p:=0;
    for i:=0 to 87 do p:=p xor ord(r[i]);
    Int2RStr(p,3,88);
    // Ergebnis
    Result:=StrPas(r);
  end
  else Result:=EmptyStr;
end;

function TSerial.StrToConfig(CfgStr : string) : TSerialConfig;
// Konfigurationsstring in Record umwandeln
// Bei einem Fehler im String ist Result.Valid:=false,
// die restlichen Einstellungen entsprechen aktueller
var
  i : integer;
  Ok : boolean;
  p : byte;
  r : array[0..127] of char;

  function RStr2Int(DefLength, Index : integer; var Value : integer) : boolean;
  // Teilstring r[Index] der Lnge DefLength in Zahl umwandeln
  // Ergebnis in Value
  // Ergebnis true, wenn String gltige Zeichen enthlt
  var
    j : integer;
    c : array[0..15] of char;
  begin
    for j:=0 to DefLength-1 do c[j]:=r[Index+j];
    c[DefLength]:=#0;
    val(c,Value,j);
    Result:=j=0;
  end;

  function Str2Char(Index : integer) : char;
  // Wandelt 3-stelligen ASCII-Kode-String in Zeichen um
  var
    j, e : integer;
    c : array[0..3] of char;
  begin
    for j:=0 to 2 do c[j]:=r[Index+j];
    c[3]:=#0;
    val(c,j,e);
    Result:=chr(j);
  end;

begin
  Result:=GetConfig;
  Result.Valid:=false;
  if Length(CfgStr)>4 then
  begin
    for i:=0 to SizeOf(r)-1 do r[i]:=#0;
    StrPCopy(r,CfgStr);
    // ID und Version
    Ok:=true;
    for i:=0 to 3 do Ok:=Ok and (r[i]=SerCfgID[i]);
    if Ok then
    begin // Parittsprfung
      p:=0;
      for i:=0 to 87 do p:=p xor ord(r[i]);
      Ok:=RStr2Int(3,88,i);
      Ok:=Ok and (p=i);
    end;
    if Ok then
    begin  // Schnittstelle
      Ok:=RStr2Int(3,4,i);
      if Ok then Result.COMPort:=i;
    end;
    if Ok then
    begin  // Baudrate
      Ok:=RStr2Int(2,7,i);
      Ok:=Ok and (i<20);  // gltige Baudrate
      if Ok then Result.Baudrate:=TBaudrate(i);
    end;
    if Ok then
    begin  // Datenbits
      Ok:=RStr2Int(1,9,i);
      Ok:=Ok and (i<5);  // gltige Anzahl datenbits
      if Ok then Result.DataBits:=TDataBits(i);
    end;
    if Ok then
    begin  // Parittsbit
      Ok:=RStr2Int(1,10,i);
      Ok:=Ok and (i<5);  // gltige Parittsangabe
      if Ok then Result.ParityBit:=TParityBit(i);
    end;
    if Ok then
    begin  // Stoppbits
      Ok:=RStr2Int(1,11,i);
      Ok:=Ok and (i<3);  // gltige Angabe
      if Ok then Result.StopBits:=TStopBits(i);
    end;
    if Ok then
    begin  // Sendepuffergre
      Ok:=RStr2Int(8,12,i);
      if Ok then Result.BufSizeTrm:=i;
    end;
    if Ok then
    begin  // Empfangspuffergre
      Ok:=RStr2Int(8,20,i);
      if Ok then Result.BufSizeRec:=i;
    end;
    if Ok then
    begin  // Handshake RTS/CTS
      Ok:=RStr2Int(1,28,i);
      if Ok then Result.HandshakeRtsCts:=i>0;
    end;
    if Ok then
    begin  // Handshake DTR/DSR
      Ok:=RStr2Int(1,29,i);
      if Ok then Result.HandshakeDtrDsr:=i>0;
    end;
    if Ok then
    begin  // Handshake XOn/XOff
      Ok:=RStr2Int(1,30,i);
      if Ok then Result.HandshakeXOnXOff:=i>0;
    end;
    if Ok then
    begin  // RTS-Zustand
      Ok:=RStr2Int(1,31,i);
      if Ok then Result.RTSActive:=i>0;
    end;
    if Ok then
    begin  // DTR-Zustand
      Ok:=RStr2Int(1,32,i);
      if Ok then Result.DTRActive:=i>0;
    end;
    // XOn-Zeichen
    if Ok then Result.XOnChar:=Str2Char(33);
    // XOff-Zeichen
    if Ok then Result.XOffChar:=Str2Char(36);
    if Ok then
    begin  // XOff-Limit
      Ok:=RStr2Int(8,39,i);
      if Ok then Result.XOffLimit:=i;
    end;
    begin  // XOn-Limit
      Ok:=RStr2Int(8,47,i);
      if Ok then Result.XOnLimit:=i;
    end;
    // Fehler-Zeichen
    if Ok then Result.ErrorChar:=Str2Char(55);
    // EOF-Zeichen
    if Ok then Result.EofChar:=Str2Char(58);
    // Ereignis-Zeichen
    if Ok then Result.EventChar:=Str2Char(61);
    if Ok then
    begin  // Continue on XOff
      Ok:=RStr2Int(1,64,i);
      if Ok then Result.ContinueOnXOff:=i>0;
    end;
    if Ok then
    begin  // Fehlerzeichen benutzen
      Ok:=RStr2Int(1,65,i);
      if Ok then Result.UseErrorChar:=i>0;
    end;
    if Ok then
    begin  // Nullzeichen entfernen
      Ok:=RStr2Int(1,66,i);
      if Ok then Result.EliminateNullChar:=i>0;
    end;
    if Ok then
    begin  // Abbruch bei Fehler
      Ok:=RStr2Int(1,67,i);
      if Ok then Result.AbortOnError:=i>0;
    end;
    if Ok then
    begin  // Timeout Empfang
      Ok:=RStr2Int(10,68,i);
      if Ok then Result.RecTimeOut:=i;
    end;
    if Ok then
    begin  // Timeout Senden
      Ok:=RStr2Int(10,78,i);
      if Ok then Result.TrmTimeOut:=i;
    end;
    Result.Valid:=Ok;
  end;
end;

function TSerial.TData_00;
// Dummy-Routine Daten bertragen
begin
  Result:=0;
end;

function TSerial.TData_95;
// Daten bertragen
// Data: Zeiger auf zu bertragende Daten
// DataSize: Umfang der zu bertragenden Daten
// Ergebnis: tatschlich bertragene (in Sendepuffer gestellte) Daten
begin
  WriteFile(FSerHandle,Data,DataSize,Result,@Overlapped);
end;

function TSerial.TData_NT;
// Daten bertragen
// Data: Zeiger auf zu bertragende Daten
// DataSize: Umfang der zu bertragenden Daten
// Ergebnis: tatschlich bertragene (in Sendepuffer gestellte) Daten
begin
  if not WriteFile(FSerHandle, Data, DataSize, Result, @Overlapped)
    and (GetLastError = ERROR_IO_PENDING) then
    GetOverlappedResult(FSerHandle, Overlapped, Result, True);
end;

function TSerial.RData_00;
// Dummy-Routine fr Daten empfangen
begin
  Result:=0;
end;

function TSerial.RData_95;
// Daten empfangen (Empfangspuffer leeren)
// Buf: Zeiger auf Puffer, welcher die Daten bernehmen soll
// BufSize: Gre des Puffers
// Ergebnis: Anzahl Datenbytes, die tatschlich in den Puffer geschrieben wurden
begin
  ReadFile(FSerHandle,Buf,BufSize,Result,@Overlapped);
end;

function TSerial.RData_NT;
// Daten empfangen (Empfangspuffer leeren)
// Buf: Zeiger auf Puffer, welcher die Daten bernehmen soll
// BufSize: Gre des Puffers
// Ergebnis: Anzahl Datenbytes, die tatschlich in den Puffer geschrieben wurden
begin
  if not ReadFile(FSerHandle, Buf, BufSize, Result, @Overlapped)
    and (GetLastError = ERROR_IO_PENDING) then
    GetOverlappedResult(FSerHandle, Overlapped, Result, True);
end;

function TSerial.TText_00;
// Dummy-Funktion zur Textbertragung
begin
  Result:=0;
end;

function TSerial.TText_95;
// Text bertragen
// s: Zu sendender Text
// Ergebnis: tatschlich bertragene (in Sendepuffer gestellte) Zeichen
//           (bei nicht geffneter Schnittstelle 0)
begin
  WriteFile(FSerHandle,s[1],Length(s),Result,@Overlapped)
end;

function TSerial.TText_NT;
// Text bertragen
// s: Zu sendender Text
// Ergebnis: tatschlich bertragene (in Sendepuffer gestellte) Zeichen
//           (bei nicht geffneter Schnittstelle 0)
begin
  if not WriteFile(FSerHandle, s[1], Length(s), Result, @Overlapped)
    and (GetLastError = ERROR_IO_PENDING) then
    GetOverlappedResult(FSerHandle, Overlapped, Result, True);
end;

function TSerial.RText_00 : string;
// Dummy-Routine fr Textempfang
begin
  Result:='';
end;

function TSerial.RText_95 : string;
// Text empfangen (Empfangspuffer leeren)
// Ergebnis: Eingelesener Text
//           (bei nicht geffneter Schnittstelle Leerstring)
var
  {$IFDEF OLDDELPHI}
  n, m : integer;
  {$ELSE}
  n, m : cardinal;
  {$ENDIF}
begin
  n:=BufRec;
  if n>0 then
  begin
    SetLength(Result,n);
    ReadFile(FSerHandle,Result[1],n,m,@Overlapped);
  end
  else Result:=EmptyStr;
end;

function TSerial.RText_NT : string;
// Text empfangen (Empfangspuffer leeren)
// Ergebnis: Eingelesener Text
//           (bei nicht geffneter Schnittstelle Leerstring)
var
  {$IFDEF OLDDELPHI}
  n, m : integer;
  {$ELSE}
  n, m : cardinal;
  {$ENDIF}
begin
  n:=BufRec;
  if n>0 then
  begin
    SetLength(Result,n);
    if not ReadFile(FSerHandle, Result[1], n, m, @Overlapped)
      and (GetLastError = ERROR_IO_PENDING) then
      GetOverlappedResult(FSerHandle, Overlapped, m, True);
  end
  else Result:=EmptyStr;
end;

(*** TSerPortThread ***)

constructor TSerPortThread.Create;
// Konstruktor des Thread
begin
  inherited Create(false);
  Serial:=SerComp;
  Priority:=Serial.ThreadPriority;
  FreeOnTerminate:=true;
end;

procedure TSerPortThread.Execute;
// Thread-Routine, wartet auf Schnittstellenereignisse
var
  {$IFDEF OLDDELPHI}
  e : integer;
  Status : integer;
  {$ELSE}
  e : cardinal;
  Status : cardinal;
  {$ENDIF}
  First : boolean;
begin
  // Thread-Routine, wird beim Start des Thread durchlaufen
  First:=true;
  while (not Terminated) do
  begin
    if (First or (WaitCommEvent(Serial.SerHandle,e,nil))) then
    begin  // An der Schnittstelle ist vorgegebenes Ereignis aufgetreten
      First:=false;
      GetCommModemStatus(Serial.SerHandle,Status);
      Serial.FIn_CTS:=(Status and MS_CTS_ON)=0;
      Serial.FIn_DSR:=(Status and MS_DSR_ON)=0;
      Serial.FIn_RI:=(Status and MS_RING_ON)=0;
      Serial.FIn_DCD:=(Status and MS_RLSD_ON)=0;
      if Assigned(Serial.OnCts) and ((e and EV_CTS)>0) then Serial.OnCts(Serial);
      if Assigned(Serial.OnDsr) and ((e and EV_DSR)>0) then Serial.OnDsr(Serial);
      if Assigned(Serial.OnRing) and ((e and EV_RING)>0) then Serial.OnRing(Serial);
      if Assigned(Serial.OnDcd) and ((e and EV_RLSD)>0) then Serial.OnDcd(Serial);
    end;
  end;
end;

(*** TSerPort ***)

constructor TSerPort.Create(AOwner: TComponent);
// Konstruktor
begin
  inherited Create(AOwner);
  FOut_DTR:=false;
  FOut_RTS:=false;
  FIn_DCD:=false;
  FIn_DSR:=false;
  FIn_CTS:=false;
  FIn_RI:=false;
  FOnCts:=nil;
  FOnDsr:=nil;
  FOnRing:=nil;
  FOnDcd:=nil;
  SerPortThread:=nil;
  FPollingMode:=false;
end;

destructor TSerPort.Destroy;
// Destruktor
begin
  CloseIt;
  inherited Destroy;
end;

function TSerPort.OpenIt : boolean;
// Schnittstelle ffnen und initialisieren
var
  c : array[0..63] of char;
  i : integer;
begin
  IsPolling:=FPollingMode;  // Polling-Modus
  // Schnittstelle ffnen
  c:='COMx'+#0+#0;
  if FCOMPort<10 then c[3]:=chr($30+FCOMPort)
  else
  begin
    c[3]:=chr($30+(FCOMPort div 10));
    c[4]:=chr($30+(FCOMPort mod 10));
  end;
  FSerHandle:=CreateFile(c,
    GENERIC_READ or GENERIC_WRITE,
    0,
    nil,
    OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,
    0);
  if (FSerHandle<>INVALID_HANDLE_VALUE) then
  begin
    with Overlapped do
    begin
      Internal:=0;
      InternalHigh:=0;
      Offset:=0;
      OffsetHigh:=0;
      hEvent:=0;
    end;
    if (not SetupComm(FSerHandle,FBufSizeRec,FBufSizeTrm)) then
    begin
      CloseHandle(FSerHandle);
      FSerHandle:=INVALID_HANDLE_VALUE;
    end;
  end;
  if (FSerHandle<>INVALID_HANDLE_VALUE) then
  begin
    // DCB
    dcb.DCBLength:=SizeOf(TDCB);
    c:='baud=9600 parity=N data=8 stop=1'+#0;
    BuildCommDCB(c,dcb);  // dcb
    // Schnittstellen initialisieren
    if (not SetCommState(FSerHandle,dcb)) then
    begin
      CloseHandle(FSerHandle);
      FSerHandle:=INVALID_HANDLE_VALUE;
    end;
  end;
  if (FSerHandle<>INVALID_HANDLE_VALUE) then
  begin
    if (not IsPolling) then
    begin   // Thread initialisieren (kein Polling Mode)
      SetCommMask(FSerHandle,EV_CTS or EV_DSR or EV_RING or EV_RLSD);  // auf nderung der Handshake-Leitungen reagieren
      SerPortThread:=TSerPortThread.Create(Self);  // Thread anlegen
    end;
    // Ausgnge gem Voreinstellung setzen
    if FOut_DTR then i:=CLRDTR
                else i:=SETDTR;
    EscapeCommFunction(FSerHandle,i);
    if FOut_RTS then i:=CLRRTS
                else i:=SETRTS;
    EscapeCommFunction(FSerHandle,i);
  end;
  Result:=FSerHandle<>INVALID_HANDLE_VALUE;
  FActive:=Result;
end;

procedure TSerPort.CloseIt;
// Schnittstelle schlieen
begin
  if FActive then
  begin
    if (not IsPolling) then
    begin  // kein Polling Mode
      SerPortThread.Terminate;  // Thread zum Beenden auffordern
      SetCommMask(FSerHandle,0);
    end;
    CloseHandle(FSerHandle);
    FSerHandle:=INVALID_HANDLE_VALUE;
    FActive:=false;
    IsPolling:=false;
  end;
end;

procedure TSerPort.SetActive(Value : boolean);
// Schnittstelle ffnen/schlieen
begin
  if Value and (not FActive) then FActive:=OpenIt  // ffnen
  else
  if (not Value) and FActive then CloseIt;  // schlieen
end;

procedure TSerPort.SetOutDtr(Value : boolean);
// DTR-Ausgang (Value=false -> "0" -> +12V)
var
  i : integer;
begin
  FOut_DTR:=Value;
  if FActive then
  begin
    if Value then i:=CLRDTR
             else i:=SETDTR;
    EscapeCommFunction(FSerHandle,i);
  end;
end;

procedure TSerPort.SetOutRts(Value : boolean);
// DTR-Ausgang (Value=false -> "0" -> +12V)
var
  i : integer;
begin
  FOut_RTS:=Value;
  if FActive then
  begin
    if Value then i:=CLRRTS
             else i:=SETRTS;
    EscapeCommFunction(FSerHandle,i);
  end;
end;

function TSerPort.GetInDCD : boolean;
// DCD-Eingang (+12V -> "0" -> Result=false)
// Im Polling Mode wird der Leitungsstatus ermittelt
var
  {$IFDEF OLDDELPHI}
  Status : integer;
  {$ELSE}
  Status : cardinal;
  {$ENDIF}
begin
  if IsPolling then
  begin
    GetCommModemStatus(FSerHandle,Status);
    FIn_DCD:=(Status and MS_RLSD_ON)=0;
  end;
  Result:=FIn_DCD;
end;

function TSerPort.GetInDSR : boolean;
// DSR-Eingang (+12V -> "0" -> Result=false)
// Im Polling Mode wird der Leitungsstatus ermittelt
var
  {$IFDEF OLDDELPHI}
  Status : integer;
  {$ELSE}
  Status : cardinal;
  {$ENDIF}
begin
  if IsPolling then
  begin
    GetCommModemStatus(FSerHandle,Status);
    FIn_DSR:=(Status and MS_DSR_ON)=0;
  end;
  Result:=FIn_DSR;
end;

function TSerPort.GetInCTS : boolean;
// CTS-Eingang (+12V -> "0" -> Result=false)
// Im Polling Mode wird der Leitungsstatus ermittelt
var
  {$IFDEF OLDDELPHI}
  Status : integer;
  {$ELSE}
  Status : cardinal;
  {$ENDIF}
begin
  if IsPolling then
  begin
    GetCommModemStatus(FSerHandle,Status);
    FIn_CTS:=(Status and MS_CTS_ON)=0;
  end;
  Result:=FIn_CTS;
end;

function TSerPort.GetInRI : boolean;
// RI-Eingang (+12V -> "0" -> Result=false)
// Im Polling Mode wird der Leitungsstatus ermittelt
var
  {$IFDEF OLDDELPHI}
  Status : integer;
  {$ELSE}
  Status : cardinal;
  {$ENDIF}
begin
  if IsPolling then
  begin
    GetCommModemStatus(FSerHandle,Status);
    FIn_RI:=(Status and MS_RING_ON)=0;
  end;
  Result:=FIn_RI;
end;

function TSerPort.OpenComm : boolean;
// Serielle Schnittstelle ffnen (public deklarierte Funktion)
// Alternative zur Eigenschaft Active
begin
  Result:=OpenIt;
end;

procedure TSerPort.CloseComm;
// Serielle Schnittstelle schlieen (public deklarierte Funktion)
// Alternative zur Eigenschaft Active
begin
  CloseIt;
end;

(*** TFormSerSel ***)

procedure TFormSerSel.FormCreate(Sender: TObject);
var
  i : integer;
begin
  // Vorhandene Schnittstellen ermitteln und Combobox entsprechend fllen
  Combobox1.Clear;
  if PortsExist then
  begin  // ComboBox entsprechend vorhandener Schnittstellen fllen
    for i:=0 to MaxPort do
      if PortNames[i]>0 then ComboBox1.Items.Add('COM'+IntToStr(PortNames[i]));
  end
end;

procedure TFormSerSel.FormShow(Sender: TObject);
begin
  if Combobox1.Items.Count>0 then
  begin  // es sind Schnittstellen vorhanden
    if CurPort=0 then CurPort:=1;
    ComboBox1.ItemIndex:=Port2Index(CurPort);
    PortsAvail:=true;
  end
  else
  begin  // keine Schnittstelle vorhanden
    Combobox1.Items.Add('keine');
    CurPort:=0;
    PortsAvail:=false;
  end;
end;

procedure TFormSerSel.ComboBox1Change(Sender: TObject);
// Auswahl der ComboBox hat sich verndert
begin
  if PortsAvail then
    CurPort:=PortNames[ComboBox1.ItemIndex];
end;

(*** TSerSel ***)

constructor TSerSel.Create(AOwner: TComponent);
// Konstruktor
begin
  inherited Create(AOwner);
  FSerial:=nil;
end;

function TSerSel.Execute : boolean;
// Auswahldialog darstellen
begin
  FormSerSel:=TFormSerSel.Create(Application); { Das Formular erzeugen }
  try
    if Assigned(Serial) then FormSerSel.CurPort:=Serial.COMPort
                        else FormSerSel.CurPort:=1;
    Result:=(FormSerSel.ShowModal=IDOK); { Ausfhren; Ergebnis basierend auf der Art des Schlieens setzen }
    if Result and (Assigned(Serial)) then Serial.COMPort:=FormSerSel.CurPort;
  finally
    FormSerSel.Free; { Formular freigeben }
  end;
end;

(*** TSerStdDlg ***)

constructor TSerStdDlg.Create(AOwner: TComponent);
// Konstruktor
var
  c : array[0..63] of char;
begin
  inherited Create(AOwner);
  FSerial:=nil;
  // COMMCONFIG und DCB initialisieren
  cc.dwSize:=SizeOf(cc);
  cc.wVersion:=1;
  cc.wReserved:=0;
  cc.dwProviderSubType:=0;
  cc.dwProviderOffset:=0;
  cc.dwProviderSize:=0;
  cc.dcb.DCBLength:=SizeOf(TDCB);
  c:='baud=9600 parity=N data=8 stop=1'+#0;
  BuildCommDCB(c,cc.dcb);  // dcb
end;

function TSerStdDlg.Execute : boolean;
// Auswahldialog darstellen
var
  c : array[0..5] of char;
  h : integer;
begin
  c:='COMx'+#0;
  if Assigned(FSerial) then c[3]:=chr($30+FSerial.COMPort)
                       else c[3]:='1';
  // In TSerial gesetzte Parameter bernehmen
  if Assigned(FSerial) then
  begin
    cc.dcb.Baudrate:=Baudrates[ord(FSerial.Baudrate)];
    cc.dcb.ByteSize:=ord(FSerial.Databits)+4;
    cc.dcb.Parity:=ord(FSerial.ParityBit);
    cc.dcb.Flags:=cc.dcb.Flags and $FFFFFFFD;  // Flag fParity lschen
    cc.dcb.Flags:=cc.dcb.Flags or (ord(FSerial.ParityBit>none) shl 1);  // Flag fParity
    cc.dcb.StopBits:=ord(FSerial.StopBits);
    if FSerial.HandshakeRtsCts then
    begin
      cc.dcb.Flags:=cc.dcb.Flags or 4;  // Flag fOutxCtsFlow setzen
      cc.dcb.Flags:=cc.dcb.Flags and $FFFFCFFF;  // Flag fRtsControl lschen
      cc.dcb.Flags:=cc.dcb.Flags or (RTS_CONTROL_HANDSHAKE shl 12);  // Flag setzen
    end
    else
    if FSerial.HandshakeXOnXOff then
      cc.dcb.Flags:=cc.dcb.Flags or $300  // Flags fOutx und fInx setzen
    else cc.dcb.Flags:=cc.dcb.Flags and $FFFFCCFF;  // relevante Flags lschen
  end;
  // Dialog aufrufen
  h:=0;
  if Owner is TForm then h:=TForm(Owner).Handle;
  Result:=CommConfigDialog(c,h,cc);
  if Result and Assigned(FSerial) then
  begin  // nderungen in TSerial-Komponente bernehmen
    case cc.dcb.BaudRate of
      CBR_110    : FSerial.Baudrate:=br_000110;
      CBR_300    : FSerial.Baudrate:=br_000300;
      CBR_600    : FSerial.Baudrate:=br_000600;
      CBR_1200   : FSerial.Baudrate:=br_001200;
      CBR_2400   : FSerial.Baudrate:=br_002400;
      CBR_4800   : FSerial.Baudrate:=br_004800;
      CBR_9600   : FSerial.Baudrate:=br_009600;
      CBR_14400  : FSerial.Baudrate:=br_014400;
      CBR_19200  : FSerial.Baudrate:=br_019200;
      CBR_38400  : FSerial.Baudrate:=br_038400;
      CBR_56000  : FSerial.Baudrate:=br_056000;
      CBR_57600  : FSerial.Baudrate:=br_057600;
      CBR_115200 : FSerial.Baudrate:=br_115200;
      CBR_128000 : FSerial.Baudrate:=br_128000;
      230400     : FSerial.Baudrate:=br_230400;
      CBR_256000 : FSerial.Baudrate:=br_256000;
      460800     : FSerial.Baudrate:=br_460800;
      921600     : FSerial.Baudrate:=br_921600;
    end { case };   // andere Werte werden ignoriert
    FSerial.Databits:=TDatabits(cc.dcb.ByteSize-4);
    FSerial.ParityBit:=TParityBit(cc.dcb.Parity);
    FSerial.StopBits:=TStopBits(cc.dcb.StopBits);
    FSerial.HandshakeRtsCts:=(cc.dcb.Flags and $3000)>0;
    FSerial.HandshakeXOnXOff:=(cc.dcb.Flags and $100)>0;
  end;
end;

(*** FormCOMSetup ***)

procedure TFormCOMSetup.FormCreate(Sender: TObject);
// Initialisierungen
var
  i : integer;
begin
  ComboBoxPort.Clear;
  if PortsExist then
  begin  // ComboBox entsprechend vorhandener Schnittstellen fllen
    for i:=0 to MaxPort do
      if PortNames[i]>0 then ComboBoxPort.Items.Add('COM'+IntToStr(PortNames[i]));
  end;
  ComboBoxPort.ItemIndex:=0;
  // Fenster
  Left:=0;
  Top:=0;
  Position:=poDesigned;
end;

procedure TFormCOMSetup.FormShow(Sender: TObject);
var
  i, j : integer;
begin
  // --- alte Einstellungen merken ---
  // LastPort:=PortNames[ComboBoxPort.ItemIndex];  // nderung V3.4
  LastPort:=ComboBoxPort.ItemIndex;  // nderung V3.4
  LastBaud:=ComboBoxBaudrate.ItemIndex;
  LastData:=ComboBoxDatabit.ItemIndex;
  LastParity:=ComboBoxParity.ItemIndex;
  LastStop:=ComboBoxStop.ItemIndex;
  LastCTS:=CheckBoxRTSCTS.Checked;
  LastDSR:=CheckBoxDTRDSR.Checked;
  LastSoft:=CheckBoxSoft.Checked;
  LastBufR:=BufSizeR;
  LastBufT:=BufSizeT;
  // --- aktuelle Einstellungen bernehmen ---
  ComboBoxPort.ItemIndex:=Port2Index(UsedPort);
  // Combobox bertragungsrate
  ComboBoxBaudrate.Clear;
  for i:=0 to 19 do
    ComboBoxBaudrate.Items.Add(IntToStr(Baudrates[i]));
  case dcb.BaudRate of
    50         : ComboBoxBaudrate.ItemIndex:=0;
    CBR_110    : ComboBoxBaudrate.ItemIndex:=1;
    150        : ComboBoxBaudrate.ItemIndex:=2;
    CBR_300    : ComboBoxBaudrate.ItemIndex:=3;
    CBR_600    : ComboBoxBaudrate.ItemIndex:=4;
    CBR_1200   : ComboBoxBaudrate.ItemIndex:=5;
    CBR_2400   : ComboBoxBaudrate.ItemIndex:=6;
    CBR_4800   : ComboBoxBaudrate.ItemIndex:=7;
    CBR_9600   : ComboBoxBaudrate.ItemIndex:=8;
    CBR_14400  : ComboBoxBaudrate.ItemIndex:=9;
    CBR_19200  : ComboBoxBaudrate.ItemIndex:=10;
    CBR_38400  : ComboBoxBaudrate.ItemIndex:=11;
    CBR_56000  : ComboBoxBaudrate.ItemIndex:=12;
    CBR_57600  : ComboBoxBaudrate.ItemIndex:=13;
    CBR_115200 : ComboBoxBaudrate.ItemIndex:=14;
    CBR_128000 : ComboBoxBaudrate.ItemIndex:=15;
    230400     : ComboBoxBaudrate.ItemIndex:=16;
    CBR_256000 : ComboBoxBaudrate.ItemIndex:=17;
    460800     : ComboBoxBaudrate.ItemIndex:=18;
    921600     : ComboBoxBaudrate.ItemIndex:=19;
    else         ComboBoxBaudrate.ItemIndex:=8;
  end { case };   // andere Werte werden ignoriert
  // Combobox Datenbit
  ComboBoxDatabit.Clear;
  for i:=4 to 8 do
    ComboBoxDatabit.Items.Add(IntToStr(i));
  ComboBoxDatabit.ItemIndex:=dcb.ByteSize-4;
  // Combobox Parittsbit
  ComboBoxParity.Clear;
  for i:=0 to 4 do
    ComboBoxParity.Items.Add(ParityNames[i]);
  ComboBoxParity.ItemIndex:=dcb.Parity;
  // Combobox Stoppbits
  ComboBoxStop.Clear;
  for i:=0 to 2 do
    ComboBoxStop.Items.Add(StopbitsNames[i]);
  ComboBoxStop.ItemIndex:=dcb.StopBits;
  // Checkboxen Handshake
  CheckBoxRTSCTS.Checked:=(GetDCBFlag(dcb,fRtsControl)>0) or (GetDCBFlag(dcb,fOutxCtsFlow)>0);
  CheckBoxDTRDSR.Checked:=(GetDCBFlag(dcb,fDtrControl)>0) or (GetDCBFlag(dcb,fOutxDsrFlow)>0);
  CheckBoxSoft.Checked:=(GetDCBFlag(dcb,fOutX)>0) or (GetDCBFlag(dcb,fInX)>0);
  // Empfangs-, Sendepuffer
  EditBufR.Text:=IntToStr(BufSizeR);
  i:=BufSizeR;
  j:=0;
  while (i and $1)=0 do
  begin
    i:=i shr 1;
    inc(j);
  end;
  UpDown1.Position:=j;
  EditBufT.Text:=IntToStr(BufSizeT);
  i:=BufSizeT;
  j:=0;
  while (i and $1)=0 do
  begin
    i:=i shr 1;
    inc(j);
  end;
  UpDown2.Position:=j;
end;

procedure TFormCOMSetup.ButtonOkClick(Sender: TObject);
begin
  // bernahme der Einstellungen in UsedPort und dcb
  UsedPort:=PortNames[ComboBoxPort.ItemIndex];
  dcb.BaudRate:=Baudrates[ComboBoxBaudrate.ItemIndex];
  dcb.ByteSize:=BYTE(ComboBoxDatabit.ItemIndex+4); // number of bits/byte, 4-8
  dcb.Parity:=BYTE(ComboBoxParity.ItemIndex);      // 0-4=no,odd,even,mark,space
  dcb.StopBits:=BYTE(ComboBoxStop.ItemIndex);      // 0,1,2 = 1, 1.5, 2
  dcb.Flags:=1;  // fBinary
  SetDCBFlag(dcb,fParity,ord(ComboBoxParity.ItemIndex>0));
  SetDCBFlag(dcb,fOutxCtsFlow,ord(CheckBoxRTSCTS.Checked));
  SetDCBFlag(dcb,fOutxDsrFlow,ord(CheckBoxDTRDSR.Checked));
  if CheckBoxDTRDSR.Checked then SetDCBFlag(dcb,fDtrControl,DTR_CONTROL_HANDSHAKE)
                            else SetDCBFlag(dcb,fDtrControl,DTR_CONTROL_DISABLE);
  // fDsrSensitivity=0
  // fTXContinueOnXoff=0
  SetDCBFlag(dcb,fOutX,ord(CheckBoxSoft.Checked));
  SetDCBFlag(dcb,fInX,ord(CheckBoxSoft.Checked));
  // fErrorChar=0
  // fNull=0
  if CheckBoxRTSCTS.Checked then SetDCBFlag(dcb,fRtsControl,RTS_CONTROL_HANDSHAKE)
                            else SetDCBFlag(dcb,fRtsControl,RTS_CONTROL_DISABLE);
  // fAbortOnError=0
  // fDummy2=0
  dcb.XonChar:=#17;
  dcb.XoffChar:=#19;
  BufSizeR:=StrToInt(EditBufR.Text);
  BufSizeT:=StrToInt(EditBufT.Text);
end;

procedure TFormCOMSetup.ButtonAbortClick(Sender: TObject);
begin
  // Abbruch: ursprngliche Einstellungen setzen
  // ComboBoxPort.ItemIndex:=PortNames[LastPort];  // nderung V3.4
  ComboBoxPort.ItemIndex:=LastPort;  // nderung V3.4
  ComboBoxBaudrate.ItemIndex:=LastBaud;
  ComboBoxDatabit.ItemIndex:=LastData;
  ComboBoxParity.ItemIndex:=LastParity;
  ComboBoxStop.ItemIndex:=LastStop;
  CheckBoxRTSCTS.Checked:=LastCTS;
  CheckBoxDTRDSR.Checked:=LastDSR;
  CheckBoxSoft.Checked:=LastSoft;
  BufSizeR:=LastBufR;
  EditBufR.Text:=IntToStr(BufSizeR);
  BufSizeT:=LastBufT;
  EditBufT.Text:=IntToStr(BufSizeT);
end;

procedure TFormCOMSetup.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  BufSizeR:= 1 shl UpDown1.Position;
  EditBufR.Text:=IntToStr(BufSizeR);
end;

procedure TFormCOMSetup.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  BufSizeT:= 1 shl UpDown2.Position;
  EditBufT.Text:=IntToStr(BufSizeT);
end;

function TFormCOMSetup.CommConfigDialogEx(var COMExtParams : TCOMExtParams) : boolean;
// Konfigurationsdialog darstellen
// COMExtParams enthlt die Vorgaben
// Ergebnis: true, wenn Dialog mit Ok geschlossen wurde
begin
  with COMExtParams do
  begin
    if (APort<1) or (APort>MaxPort+1) then APort:=1;
    UsedPort:=APort;  // nderung V3.32
    dcb:=ADCB;
    BufSizeT:=ABufSizeT;
    BufSizeR:=ABufSizeR;
    Position:=APosition;
    Left:=ALeft;
    Top:=ATop;
    Parent:=AParent;
    Result:=ShowModal=mrOk;
    if Result then
    begin
      APort:=UsedPort;  // nderung V3.32
      ADCB:=dcb;
      ABufSizeT:=BufSizeT;
      ABufSizeR:=BufSizeR;
    end;
  end;
end;

(*** TSerExtDlg ***)

constructor TSerExtDlg.Create(AOwner: TComponent);
// Konstruktor
var
  c : array[0..63] of char;
begin
  inherited Create(AOwner);
  FSerial:=nil;
  // DCB initialisieren
  dcb.DCBLength:=SizeOf(TDCB);
  c:='baud=9600 parity=N data=8 stop=1'+#0;
  BuildCommDCB(c,dcb);  // dcb
  // Fenster
  FPositionDlg:=poDesigned;
  FLeftDlg:=0;
  FTopDlg:=0;
end;

function TSerExtDlg.Execute : boolean;
// Auswahldialog darstellen
var
  COMExtParams : TCOMExtParams;
begin
  // In TSerial gesetzte Parameter bernehmen
  if Assigned(FSerial) then
  begin
    COMExtParams.APort:=FSerial.COMPort;
    dcb.Baudrate:=Baudrates[ord(FSerial.Baudrate)];
    dcb.ByteSize:=ord(FSerial.Databits)+4;
    dcb.Parity:=ord(FSerial.ParityBit);
    SetDCBFlag(dcb,fParity,ord(FSerial.ParityBit>none));
    dcb.StopBits:=ord(FSerial.StopBits);
    SetDCBFlag(dcb,fOutxCtsFlow,ord(FSerial.HandshakeRtsCts));
    if FSerial.HandshakeRtsCts then SetDCBFlag(dcb,fRtsControl,RTS_CONTROL_HANDSHAKE)
                               else SetDCBFlag(dcb,fRtsControl,RTS_CONTROL_DISABLE);
    SetDCBFlag(dcb,fOutxDsrFlow,ord(FSerial.HandshakeDtrDsr));
    if FSerial.HandshakeDtrDsr then SetDCBFlag(dcb,fDtrControl,DTR_CONTROL_HANDSHAKE)
                               else SetDCBFlag(dcb,fDtrControl,DTR_CONTROL_DISABLE);
    SetDCBFlag(dcb,fOutX,ord(FSerial.HandshakeXOnXOff));
    SetDCBFlag(dcb,fInX,ord(FSerial.HandshakeXOnXOff));
    COMExtParams.ABufSizeR:=FSerial.BufSizeRec;
    COMExtParams.ABufSizeT:=FSerial.BufSizeTrm;
  end
  else
  begin
    COMExtParams.APort:=1;
    COMExtParams.ABufSizeR:=2048;
    COMExtParams.ABufSizeT:=2048;
  end;
  // Dialog aufrufen
  FormCOMSetup:=TFormCOMSetup.Create(Application); { Das Formular erzeugen }
  COMExtParams.ADCB:=dcb;
  COMExtParams.APosition:=PositionDlg;
  COMExtParams.ALeft:=LeftDlg;
  COMExtParams.ATop:=TopDlg;
  if Owner is TForm then
    COMExtParams.AParent:=(Owner as TForm).Parent;
  try
    Result:=FormCOMSetup.CommConfigDialogEx(COMExtParams);
  finally
    FormCOMSetup.Free; { Formular freigeben }
  end;
  // Ergebnis auswerten
  if Result and Assigned(FSerial) then
  begin  // nderungen in TSerial-Komponente bernehmen
    FSerial.COMPort:=COMExtParams.APort;
    dcb:=COMExtParams.ADCB;
    case dcb.BaudRate of
      50         : FSerial.Baudrate:=br_000050;
      CBR_110    : FSerial.Baudrate:=br_000110;
      150        : FSerial.Baudrate:=br_000150;
      CBR_300    : FSerial.Baudrate:=br_000300;
      CBR_600    : FSerial.Baudrate:=br_000600;
      CBR_1200   : FSerial.Baudrate:=br_001200;
      CBR_2400   : FSerial.Baudrate:=br_002400;
      CBR_4800   : FSerial.Baudrate:=br_004800;
      CBR_9600   : FSerial.Baudrate:=br_009600;
      CBR_14400  : FSerial.Baudrate:=br_014400;
      CBR_19200  : FSerial.Baudrate:=br_019200;
      CBR_38400  : FSerial.Baudrate:=br_038400;
      CBR_56000  : FSerial.Baudrate:=br_056000;
      CBR_57600  : FSerial.Baudrate:=br_057600;
      CBR_115200 : FSerial.Baudrate:=br_115200;
      CBR_128000 : FSerial.Baudrate:=br_128000;
      230400     : FSerial.Baudrate:=br_230400;
      CBR_256000 : FSerial.Baudrate:=br_256000;
      460800     : FSerial.Baudrate:=br_460800;
      921600     : FSerial.Baudrate:=br_921600;
    end { case };   // andere Werte werden ignoriert
    FSerial.Databits:=TDatabits(dcb.ByteSize-4);
    FSerial.ParityBit:=TParityBit(dcb.Parity);
    FSerial.StopBits:=TStopBits(dcb.StopBits);
    FSerial.HandshakeRtsCts:=GetDCBFlag(dcb,fOutxCtsFlow)>0;
    FSerial.HandshakeDtrDsr:=GetDCBFlag(dcb,fOutxDsrFlow)>0;
    FSerial.HandshakeXOnXOff:=GetDCBFlag(dcb,fInX)>0;
    FSerial.BufSizeRec:=COMExtParams.ABufSizeR;
    FSerial.BufSizeTrm:=COMExtParams.ABufSizeT;
  end;
end;

(*** TCOMComboBox ***)

constructor TCOMComboBox.Create(AOwner: TComponent);
// Konstruktor
var
  i : integer;
begin
  inherited Create(AOwner);
  Parent:=AOwner as TWinControl;
  Style:=csDropDownList;
  Enabled:=true;
  DropDownCount:=MaxPort+1;
  Width:=57;
  Serial:=nil;
  if DropDownCount>8 then DropDownCount:=8;
  if PortsExist then
  begin  // ComboBox entsprechend vorhandener Schnittstellen fllen
    for i:=0 to MaxPort do
      if PortNames[i]>0 then Items.Add('COM'+IntToStr(PortNames[i]));
  end
  else Items.Add('keinen');
  ItemIndex:=0;
end;

procedure TCOMComboBox.SetSelectedPort(Value : integer);
// Schnittstelle auswhlen
// Die Wahl einer nicht vorhandenen Schnittstelle wird ignoriert
// Ergibt sich eine nderung der Schnittstelle, wird das Ereignis
// OnChange ausgelst
var
  i : integer;
begin
  if (Value>0) and (Value<=MaxPort+1) then
  begin
    if AvailPorts[Value-1] then
    begin  // angegebene Schnittstelle existiert
      for i:=0 to MaxPort do  // Schnittstelle -> ItemIndex
        if PortNames[i]=Value then
        begin
          ItemIndex:=i;
          if FSerial<>nil then FSerial.COMPort:=Value;
          Change;
        end;
    end;
  end;
end;

function TCOMComboBox.GetSelectedPort : integer;
begin
  if PortsExist then Result:=PortNames[ItemIndex]
                else Result:=0;
end;

procedure TCOMComboBox.Change;
begin
  if FSerial<>nil then
  begin
    if PortsExist then FSerial.COMPort:=PortNames[ItemIndex]
                  else FSerial.COMPort:=0;
  end;
  inherited Change;
end;

(******)

procedure Register;
// Komponentenregistrierung
begin
  RegisterComponents('Toolbox', [TSerial,TSerPort,TSerSel,TSerStdDlg,TSerExtDlg,TCOMComboBox]);
end;

begin
  CheckSerPorts;
end.

